(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("rxjs/Rx"), require("@angular/core"), require("@angular/forms"), require("@angular/common"), require("@angular/http"));
	else if(typeof define === 'function' && define.amd)
		define("angular2-font-picker", ["rxjs/Rx", "@angular/core", "@angular/forms", "@angular/common", "@angular/http"], factory);
	else if(typeof exports === 'object')
		exports["angular2-font-picker"] = factory(require("rxjs/Rx"), require("@angular/core"), require("@angular/forms"), require("@angular/common"), require("@angular/http"));
	else
		root["angular2-font-picker"] = factory(root["rxjs/Rx"], root["@angular/core"], root["@angular/forms"], root["@angular/common"], root["@angular/http"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_27__, __WEBPACK_EXTERNAL_MODULE_28__, __WEBPACK_EXTERNAL_MODULE_29__, __WEBPACK_EXTERNAL_MODULE_31__, __WEBPACK_EXTERNAL_MODULE_42__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	function __export(m) {
	    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
	}
	__export(__webpack_require__(1));
	__export(__webpack_require__(46));
	__export(__webpack_require__(47));
	__export(__webpack_require__(32));
	__export(__webpack_require__(43));
	__export(__webpack_require__(48));
	

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var WebFont = __webpack_require__(2);
	__webpack_require__(3);
	__webpack_require__(25);
	var Rx_1 = __webpack_require__(27);
	var core_1 = __webpack_require__(28);
	var forms_1 = __webpack_require__(29);
	var angular2_perfect_scrollbar_1 = __webpack_require__(30);
	var font_picker_service_1 = __webpack_require__(32);
	var interfaces_1 = __webpack_require__(43);
	var FontPickerComponent = (function () {
	    function FontPickerComponent(el, service) {
	        var _this = this;
	        this.el = el;
	        this.service = service;
	        this.PERFECT_SCROLLBAR_CONFIG = {
	            suppressScrollX: true
	        };
	        this.styles = [];
	        this.presetFonts = [];
	        this.googleFonts = [];
	        this.dialogArrowSize = 10;
	        this.dialogArrowOffset = 15;
	        this.searchTerm = new forms_1.FormControl('');
	        this.fontAmount = 5;
	        this.loadedFonts = 0;
	        this.loading = true;
	        this.searchTerm
	            .valueChanges
	            .debounceTime(500)
	            .distinctUntilChanged()
	            .subscribe(function (text) {
	            if (_this.fpPresetFonts && _this.fpPresetFonts.length) {
	                _this.listLabel = _this.fpPresetLabel;
	            }
	            else {
	                if (!text) {
	                    _this.listLabel = "Popular fonts";
	                }
	                else {
	                    _this.listLabel = "Search results";
	                }
	                _this.searchGoogleFonts(text);
	            }
	        });
	        // Used to handle font loading. Don't allow too many loading requests in a short time span.
	        var scrollEndStream = Rx_1.Observable.fromEvent(el.nativeElement, 'ps-y-reach-end').debounceTime(150);
	        scrollEndStream.subscribe(function (_) { _this.loadMoreFonts(); });
	        this.testContainer = document.createElement('span');
	        this.testContainer.innerHTML = Array(100).join('wi');
	        this.testContainer.style.cssText = [
	            'position:absolute',
	            'width:auto',
	            'font-size:128px',
	            'left:-99999px'
	        ].join(' !important;');
	    }
	    FontPickerComponent.prototype.setDialog = function (instance, elementRef, font, fpPosition, fpPositionOffset, fpPositionRelativeToArrow, fpPresetLabel, fpPresetFonts, fpUploadButton, fpUploadButtonClass, fpUploadButtonText, fpCancelButton, fpCancelButtonClass, fpCancelButtonText, fpHeight, fpWidth) {
	        var _this = this;
	        this.font = font;
	        this.initialFont = font;
	        this.styles = font.styles;
	        this.directiveInstance = instance;
	        this.directiveElementRef = elementRef;
	        this.fpPosition = fpPosition;
	        this.fpPositionOffset = parseInt(fpPositionOffset);
	        if (!fpPositionRelativeToArrow) {
	            this.dialogArrowOffset = 0;
	        }
	        this.fpPresetLabel = fpPresetLabel;
	        this.fpPresetFonts = fpPresetFonts;
	        this.fpCancelButton = fpCancelButton;
	        this.fpCancelButtonText = fpCancelButtonText;
	        this.fpCancelButtonClass = fpCancelButtonClass;
	        this.fpUploadButton = fpUploadButton;
	        this.fpUploadButtonText = fpUploadButtonText;
	        this.fpUploadButtonClass = fpUploadButtonClass;
	        this.fpWidth = parseInt(fpWidth);
	        this.fpHeight = parseInt(fpHeight);
	        this.listLabel = "Loading fonts...";
	        this.service.getAllFonts('popularity').subscribe(function (data) {
	            _this.loading = false;
	            _this.googleFonts = data.items.map(function (font) { return _this.convertGoogleFont(font); });
	            // Find styles for initial font
	            var searchFont = _this.findFont(_this.initialFont.family, true);
	            if (searchFont) {
	                _this.font.files = searchFont.files;
	                _this.font.styles = searchFont.styles;
	                _this.loadGoogleFonts([_this.font]);
	            }
	            // Load Open Sans if available
	            var openSans = _this.googleFonts.find(function (font) { return font.family == "Open sans"; });
	            _this.loadGoogleFonts([openSans]);
	            _this.setDisplayedFontSource();
	        }, function (err) { return console.log(err); });
	    };
	    FontPickerComponent.prototype.convertGoogleFont = function (font) {
	        var convertedFont = new interfaces_1.Font({
	            family: font.family,
	            styles: font.variants,
	            files: font.files,
	            style: null,
	            size: 14
	        });
	        return convertedFont;
	    };
	    FontPickerComponent.prototype.updateDialog = function (font, fpPresetLabel, fpPresetFonts) {
	        this.initialFont = font;
	        this.styles = font.styles;
	        this.fpPresetLabel = fpPresetLabel;
	        this.fpPresetFonts = fpPresetFonts;
	        this.setDisplayedFontSource();
	    };
	    FontPickerComponent.prototype.setDisplayedFontSource = function () {
	        if (this.fpPresetFonts && this.fpPresetFonts.length) {
	            this.setcurrentFonts(this.getPresetFonts());
	        }
	        else {
	            this.setcurrentFonts(this.googleFonts);
	        }
	    };
	    FontPickerComponent.prototype.getPresetFonts = function () {
	        var _this = this;
	        var presetFonts = [];
	        if (this.googleFonts && this.fpPresetFonts && this.fpPresetFonts.length) {
	            this.fpPresetFonts.forEach(function (font) {
	                var fontClass = _this.findFont(font, true);
	                if (!fontClass) {
	                    fontClass = new interfaces_1.Font({
	                        family: font,
	                        size: 14,
	                        style: "regular",
	                        styles: ["regular", "italic", "700", "700italic"]
	                    });
	                }
	                presetFonts.push(fontClass);
	            });
	            this.presetFonts = presetFonts;
	            return presetFonts;
	        }
	    };
	    FontPickerComponent.prototype.setcurrentFonts = function (target) {
	        var _this = this;
	        if (target == this.currentFonts)
	            return;
	        this.currentFonts = target;
	        this.loadedFonts = this.fontAmount;
	        var initialFonts = this.currentFonts.slice(0, this.fontAmount);
	        this.loadGoogleFonts(initialFonts);
	        setTimeout(function () { _this.scrollbar.scrollTo(0); }, 0);
	    };
	    FontPickerComponent.prototype.findFont = function (searchVal, exactMatch) {
	        if (exactMatch === void 0) { exactMatch = false; }
	        return this.findFonts(searchVal, exactMatch)[0];
	    };
	    FontPickerComponent.prototype.findFonts = function (searchVal, exactMatch) {
	        if (exactMatch === void 0) { exactMatch = false; }
	        searchVal = searchVal.toLowerCase();
	        var fullmatchFonts = [];
	        var candidateFonts = [];
	        this.googleFonts.forEach(function (font) {
	            if (searchVal === font.family.toLowerCase()) {
	                fullmatchFonts.push(font);
	                return;
	            }
	            if (exactMatch == false && font.family.toLowerCase().includes(searchVal)) {
	                candidateFonts.push(font);
	            }
	        });
	        var resultFonts = fullmatchFonts.concat(candidateFonts);
	        return resultFonts;
	    };
	    FontPickerComponent.prototype.ngOnInit = function () {
	        var _this = this;
	        this.listenerResize = function () { _this.onResize(); };
	        this.listenerMouseDown = function (event) { _this.onMouseDown(event); };
	        this.openFontPicker();
	    };
	    FontPickerComponent.prototype.onResize = function () {
	        if (this.position === 'fixed') {
	            this.setDialogPosition();
	        }
	    };
	    FontPickerComponent.prototype.onMouseDown = function (event) {
	        if (!this.isDescendant(this.el.nativeElement, event.target) &&
	            event.target != this.directiveElementRef.nativeElement) {
	            this.closeFontPicker();
	        }
	    };
	    FontPickerComponent.prototype.onSelectFont = function (font) {
	        var size = this.font.size;
	        this.font.family = font.family;
	        this.font.styles = font.styles;
	        this.font.files = font.files;
	        this.font.size = size;
	        this.font.style = font.styles.indexOf("regular") > -1 ? "regular" : font.styles[0];
	    };
	    FontPickerComponent.prototype.loadMoreFonts = function () {
	        var _this = this;
	        if (this.loading == false && this.loadedFonts < this.currentFonts.length) {
	            var moreFonts = this.currentFonts.slice(this.loadedFonts, this.loadedFonts + this.fontAmount);
	            this.loadGoogleFonts(moreFonts);
	            this.loadedFonts += moreFonts.length;
	            setTimeout(function () { _this.scrollbar.update(); }, 0);
	        }
	    };
	    FontPickerComponent.prototype.onSearchReset = function (event) {
	        this.searchTerm.updateValue('');
	        this.setcurrentFonts(this.googleFonts);
	    };
	    FontPickerComponent.prototype.searchGoogleFonts = function (value) {
	        if (!value) {
	            this.onSearchReset();
	            return;
	        }
	        value = value.toLowerCase();
	        var searchResult = Array();
	        if (this.googleFonts) {
	            this.loadedFonts = this.fontAmount;
	            searchResult = this.findFonts(value, false);
	            this.setcurrentFonts(searchResult);
	        }
	    };
	    FontPickerComponent.prototype.isDescendant = function (parent, child) {
	        var node = child.parentNode;
	        while (node !== null) {
	            if (node === parent) {
	                return true;
	            }
	            node = node.parentNode;
	        }
	        return false;
	    };
	    FontPickerComponent.prototype.openFontPicker = function () {
	        if (!this.show) {
	            this.setDialogPosition();
	            this.searchTerm.updateValue('');
	            window.addEventListener('resize', this.listenerResize);
	            document.addEventListener('mousedown', this.listenerMouseDown);
	            this.show = true;
	        }
	    };
	    FontPickerComponent.prototype.closeFontPicker = function () {
	        this.show = false;
	        window.removeEventListener('resize', this.listenerResize);
	        document.removeEventListener('mouseup', this.listenerMouseDown);
	    };
	    FontPickerComponent.prototype.isFontAvailable = function (font) {
	        if (!this.testWidth) {
	            this.testContainer.style.fontFamily = 'monospace';
	            document.body.appendChild(this.testContainer);
	            this.testWidth = this.testContainer.clientWidth;
	            document.body.removeChild(this.testContainer);
	        }
	        this.testContainer.style.fontFamily = font.family + ', monospace';
	        document.body.appendChild(this.testContainer);
	        var width = this.testContainer.clientWidth;
	        document.body.removeChild(this.testContainer);
	        return width != this.testWidth;
	    };
	    FontPickerComponent.prototype.uploadFontFiles = function () {
	    };
	    FontPickerComponent.prototype.cancelFontSelect = function () {
	        this.font = this.initialFont;
	        this.closeFontPicker();
	    };
	    FontPickerComponent.prototype.loadGoogleFonts = function (fonts) {
	        var _this = this;
	        fonts.slice(0, this.fontAmount).forEach(function (font) {
	            if (font && font.files && !_this.isFontAvailable(font)) {
	                var style = font.styles.indexOf("regular") > -1 ? '' : ":" + font.styles.find(function (x) { return !isNaN(x); });
	                try {
	                    WebFont.load({
	                        google: {
	                            families: [font.family + ":" + style]
	                        }
	                    });
	                }
	                catch (e) {
	                    console.warn("Problem with loading font:", font);
	                }
	            }
	        });
	    };
	    FontPickerComponent.prototype.onFontStyleChange = function ($event, font) {
	        var str = this.font.family + ":" + $event.srcElement.value;
	        if (font.files) {
	            WebFont.load({
	                google: {
	                    families: [str]
	                }
	            });
	        }
	    };
	    FontPickerComponent.prototype.createDialogBox = function (element, offset) {
	        return {
	            top: element.getBoundingClientRect().top + (offset ? window.pageYOffset : 0),
	            left: element.getBoundingClientRect().left + (offset ? window.pageXOffset : 0),
	            width: element.offsetWidth,
	            height: element.offsetHeight
	        };
	    };
	    FontPickerComponent.prototype.setDialogPosition = function () {
	        var node = this.directiveElementRef.nativeElement, parentNode = null, position = 'static';
	        while (node !== null && node.tagName !== 'HTML') {
	            position = window.getComputedStyle(node).getPropertyValue("position");
	            if (position !== 'static' && parentNode === null) {
	                parentNode = node;
	            }
	            if (position === 'fixed') {
	                break;
	            }
	            node = node.parentNode;
	        }
	        if (position !== 'fixed') {
	            var boxDirective = this.createDialogBox(this.directiveElementRef.nativeElement, true);
	            if (parentNode === null) {
	                parentNode = node;
	            }
	            var boxParent = this.createDialogBox(parentNode, true);
	            this.top = boxDirective.top - boxParent.top;
	            this.left = boxDirective.left - boxParent.left;
	        }
	        else {
	            var boxDirective = this.createDialogBox(this.directiveElementRef.nativeElement, false);
	            this.top = boxDirective.top;
	            this.left = boxDirective.left;
	            this.position = 'fixed';
	        }
	        if (this.fpPosition === 'left') {
	            this.top += boxDirective.height * this.fpPositionOffset / 100 - this.dialogArrowOffset;
	            this.left -= this.fpWidth + this.dialogArrowSize;
	        }
	        else if (this.fpPosition === 'top') {
	            this.top -= this.fpHeight + this.dialogArrowSize;
	            this.left += this.fpPositionOffset / 100 * boxDirective.width - this.dialogArrowOffset;
	            this.arrowTop = this.fpHeight - 1;
	        }
	        else if (this.fpPosition === 'bottom') {
	            this.top += boxDirective.height + this.dialogArrowSize;
	            this.left += this.fpPositionOffset / 100 * boxDirective.width - this.dialogArrowOffset;
	        }
	        else {
	            this.top += boxDirective.height * this.fpPositionOffset / 100 - this.dialogArrowOffset;
	            this.left += boxDirective.width + this.dialogArrowSize;
	        }
	    };
	    __decorate([
	        core_1.ViewChild(angular2_perfect_scrollbar_1.PerfectScrollbarComponent), 
	        __metadata('design:type', angular2_perfect_scrollbar_1.PerfectScrollbarComponent)
	    ], FontPickerComponent.prototype, "scrollbar", void 0);
	    FontPickerComponent = __decorate([
	        core_1.Component({
	            selector: 'font-picker',
	            template: __webpack_require__(44),
	            styles: [__webpack_require__(45)]
	        }), 
	        __metadata('design:paramtypes', [core_1.ElementRef, font_picker_service_1.FontPickerService])
	    ], FontPickerComponent);
	    return FontPickerComponent;
	}());
	exports.FontPickerComponent = FontPickerComponent;
	

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/* Web Font Loader v1.6.26 - (c) Adobe Systems, Google. License: Apache 2.0 */(function(){function aa(a,b,c){return a.call.apply(a.bind,arguments)}function ba(a,b,c){if(!a)throw Error();if(2<arguments.length){var d=Array.prototype.slice.call(arguments,2);return function(){var c=Array.prototype.slice.call(arguments);Array.prototype.unshift.apply(c,d);return a.apply(b,c)}}return function(){return a.apply(b,arguments)}}function p(a,b,c){p=Function.prototype.bind&&-1!=Function.prototype.bind.toString().indexOf("native code")?aa:ba;return p.apply(null,arguments)}var q=Date.now||function(){return+new Date};function ca(a,b){this.a=a;this.m=b||a;this.c=this.m.document}var da=!!window.FontFace;function t(a,b,c,d){b=a.c.createElement(b);if(c)for(var e in c)c.hasOwnProperty(e)&&("style"==e?b.style.cssText=c[e]:b.setAttribute(e,c[e]));d&&b.appendChild(a.c.createTextNode(d));return b}function u(a,b,c){a=a.c.getElementsByTagName(b)[0];a||(a=document.documentElement);a.insertBefore(c,a.lastChild)}function v(a){a.parentNode&&a.parentNode.removeChild(a)}
	function w(a,b,c){b=b||[];c=c||[];for(var d=a.className.split(/\s+/),e=0;e<b.length;e+=1){for(var f=!1,g=0;g<d.length;g+=1)if(b[e]===d[g]){f=!0;break}f||d.push(b[e])}b=[];for(e=0;e<d.length;e+=1){f=!1;for(g=0;g<c.length;g+=1)if(d[e]===c[g]){f=!0;break}f||b.push(d[e])}a.className=b.join(" ").replace(/\s+/g," ").replace(/^\s+|\s+$/,"")}function y(a,b){for(var c=a.className.split(/\s+/),d=0,e=c.length;d<e;d++)if(c[d]==b)return!0;return!1}
	function z(a){if("string"===typeof a.f)return a.f;var b=a.m.location.protocol;"about:"==b&&(b=a.a.location.protocol);return"https:"==b?"https:":"http:"}function ea(a){return a.m.location.hostname||a.a.location.hostname}
	function A(a,b,c){function d(){k&&e&&f&&(k(g),k=null)}b=t(a,"link",{rel:"stylesheet",href:b,media:"all"});var e=!1,f=!0,g=null,k=c||null;da?(b.onload=function(){e=!0;d()},b.onerror=function(){e=!0;g=Error("Stylesheet failed to load");d()}):setTimeout(function(){e=!0;d()},0);u(a,"head",b)}
	function B(a,b,c,d){var e=a.c.getElementsByTagName("head")[0];if(e){var f=t(a,"script",{src:b}),g=!1;f.onload=f.onreadystatechange=function(){g||this.readyState&&"loaded"!=this.readyState&&"complete"!=this.readyState||(g=!0,c&&c(null),f.onload=f.onreadystatechange=null,"HEAD"==f.parentNode.tagName&&e.removeChild(f))};e.appendChild(f);setTimeout(function(){g||(g=!0,c&&c(Error("Script load timeout")))},d||5E3);return f}return null};function C(){this.a=0;this.c=null}function D(a){a.a++;return function(){a.a--;E(a)}}function F(a,b){a.c=b;E(a)}function E(a){0==a.a&&a.c&&(a.c(),a.c=null)};function G(a){this.a=a||"-"}G.prototype.c=function(a){for(var b=[],c=0;c<arguments.length;c++)b.push(arguments[c].replace(/[\W_]+/g,"").toLowerCase());return b.join(this.a)};function H(a,b){this.c=a;this.f=4;this.a="n";var c=(b||"n4").match(/^([nio])([1-9])$/i);c&&(this.a=c[1],this.f=parseInt(c[2],10))}function fa(a){return I(a)+" "+(a.f+"00")+" 300px "+J(a.c)}function J(a){var b=[];a=a.split(/,\s*/);for(var c=0;c<a.length;c++){var d=a[c].replace(/['"]/g,"");-1!=d.indexOf(" ")||/^\d/.test(d)?b.push("'"+d+"'"):b.push(d)}return b.join(",")}function K(a){return a.a+a.f}function I(a){var b="normal";"o"===a.a?b="oblique":"i"===a.a&&(b="italic");return b}
	function ga(a){var b=4,c="n",d=null;a&&((d=a.match(/(normal|oblique|italic)/i))&&d[1]&&(c=d[1].substr(0,1).toLowerCase()),(d=a.match(/([1-9]00|normal|bold)/i))&&d[1]&&(/bold/i.test(d[1])?b=7:/[1-9]00/.test(d[1])&&(b=parseInt(d[1].substr(0,1),10))));return c+b};function ha(a,b){this.c=a;this.f=a.m.document.documentElement;this.h=b;this.a=new G("-");this.j=!1!==b.events;this.g=!1!==b.classes}function ia(a){a.g&&w(a.f,[a.a.c("wf","loading")]);L(a,"loading")}function M(a){if(a.g){var b=y(a.f,a.a.c("wf","active")),c=[],d=[a.a.c("wf","loading")];b||c.push(a.a.c("wf","inactive"));w(a.f,c,d)}L(a,"inactive")}function L(a,b,c){if(a.j&&a.h[b])if(c)a.h[b](c.c,K(c));else a.h[b]()};function ja(){this.c={}}function ka(a,b,c){var d=[],e;for(e in b)if(b.hasOwnProperty(e)){var f=a.c[e];f&&d.push(f(b[e],c))}return d};function N(a,b){this.c=a;this.f=b;this.a=t(this.c,"span",{"aria-hidden":"true"},this.f)}function O(a){u(a.c,"body",a.a)}function P(a){return"display:block;position:absolute;top:-9999px;left:-9999px;font-size:300px;width:auto;height:auto;line-height:normal;margin:0;padding:0;font-variant:normal;white-space:nowrap;font-family:"+J(a.c)+";"+("font-style:"+I(a)+";font-weight:"+(a.f+"00")+";")};function Q(a,b,c,d,e,f){this.g=a;this.j=b;this.a=d;this.c=c;this.f=e||3E3;this.h=f||void 0}Q.prototype.start=function(){var a=this.c.m.document,b=this,c=q(),d=new Promise(function(d,e){function k(){q()-c>=b.f?e():a.fonts.load(fa(b.a),b.h).then(function(a){1<=a.length?d():setTimeout(k,25)},function(){e()})}k()}),e=new Promise(function(a,d){setTimeout(d,b.f)});Promise.race([e,d]).then(function(){b.g(b.a)},function(){b.j(b.a)})};function R(a,b,c,d,e,f,g){this.v=a;this.B=b;this.c=c;this.a=d;this.s=g||"BESbswy";this.f={};this.w=e||3E3;this.u=f||null;this.o=this.j=this.h=this.g=null;this.g=new N(this.c,this.s);this.h=new N(this.c,this.s);this.j=new N(this.c,this.s);this.o=new N(this.c,this.s);a=new H(this.a.c+",serif",K(this.a));a=P(a);this.g.a.style.cssText=a;a=new H(this.a.c+",sans-serif",K(this.a));a=P(a);this.h.a.style.cssText=a;a=new H("serif",K(this.a));a=P(a);this.j.a.style.cssText=a;a=new H("sans-serif",K(this.a));a=
	P(a);this.o.a.style.cssText=a;O(this.g);O(this.h);O(this.j);O(this.o)}var S={D:"serif",C:"sans-serif"},T=null;function U(){if(null===T){var a=/AppleWebKit\/([0-9]+)(?:\.([0-9]+))/.exec(window.navigator.userAgent);T=!!a&&(536>parseInt(a[1],10)||536===parseInt(a[1],10)&&11>=parseInt(a[2],10))}return T}R.prototype.start=function(){this.f.serif=this.j.a.offsetWidth;this.f["sans-serif"]=this.o.a.offsetWidth;this.A=q();la(this)};
	function ma(a,b,c){for(var d in S)if(S.hasOwnProperty(d)&&b===a.f[S[d]]&&c===a.f[S[d]])return!0;return!1}function la(a){var b=a.g.a.offsetWidth,c=a.h.a.offsetWidth,d;(d=b===a.f.serif&&c===a.f["sans-serif"])||(d=U()&&ma(a,b,c));d?q()-a.A>=a.w?U()&&ma(a,b,c)&&(null===a.u||a.u.hasOwnProperty(a.a.c))?V(a,a.v):V(a,a.B):na(a):V(a,a.v)}function na(a){setTimeout(p(function(){la(this)},a),50)}function V(a,b){setTimeout(p(function(){v(this.g.a);v(this.h.a);v(this.j.a);v(this.o.a);b(this.a)},a),0)};function W(a,b,c){this.c=a;this.a=b;this.f=0;this.o=this.j=!1;this.s=c}var X=null;W.prototype.g=function(a){var b=this.a;b.g&&w(b.f,[b.a.c("wf",a.c,K(a).toString(),"active")],[b.a.c("wf",a.c,K(a).toString(),"loading"),b.a.c("wf",a.c,K(a).toString(),"inactive")]);L(b,"fontactive",a);this.o=!0;oa(this)};
	W.prototype.h=function(a){var b=this.a;if(b.g){var c=y(b.f,b.a.c("wf",a.c,K(a).toString(),"active")),d=[],e=[b.a.c("wf",a.c,K(a).toString(),"loading")];c||d.push(b.a.c("wf",a.c,K(a).toString(),"inactive"));w(b.f,d,e)}L(b,"fontinactive",a);oa(this)};function oa(a){0==--a.f&&a.j&&(a.o?(a=a.a,a.g&&w(a.f,[a.a.c("wf","active")],[a.a.c("wf","loading"),a.a.c("wf","inactive")]),L(a,"active")):M(a.a))};function pa(a){this.j=a;this.a=new ja;this.h=0;this.f=this.g=!0}pa.prototype.load=function(a){this.c=new ca(this.j,a.context||this.j);this.g=!1!==a.events;this.f=!1!==a.classes;qa(this,new ha(this.c,a),a)};
	function ra(a,b,c,d,e){var f=0==--a.h;(a.f||a.g)&&setTimeout(function(){var a=e||null,k=d||null||{};if(0===c.length&&f)M(b.a);else{b.f+=c.length;f&&(b.j=f);var h,m=[];for(h=0;h<c.length;h++){var l=c[h],n=k[l.c],r=b.a,x=l;r.g&&w(r.f,[r.a.c("wf",x.c,K(x).toString(),"loading")]);L(r,"fontloading",x);r=null;null===X&&(X=window.FontFace?(x=/Gecko.*Firefox\/(\d+)/.exec(window.navigator.userAgent))?42<parseInt(x[1],10):!0:!1);X?r=new Q(p(b.g,b),p(b.h,b),b.c,l,b.s,n):r=new R(p(b.g,b),p(b.h,b),b.c,l,b.s,a,
	n);m.push(r)}for(h=0;h<m.length;h++)m[h].start()}},0)}function qa(a,b,c){var d=[],e=c.timeout;ia(b);var d=ka(a.a,c,a.c),f=new W(a.c,b,e);a.h=d.length;b=0;for(c=d.length;b<c;b++)d[b].load(function(b,d,c){ra(a,f,b,d,c)})};function sa(a,b){this.c=a;this.a=b}function ta(a,b,c){var d=z(a.c);a=(a.a.api||"fast.fonts.net/jsapi").replace(/^.*http(s?):(\/\/)?/,"");return d+"//"+a+"/"+b+".js"+(c?"?v="+c:"")}
	sa.prototype.load=function(a){function b(){if(f["__mti_fntLst"+d]){var c=f["__mti_fntLst"+d](),e=[],h;if(c)for(var m=0;m<c.length;m++){var l=c[m].fontfamily;void 0!=c[m].fontStyle&&void 0!=c[m].fontWeight?(h=c[m].fontStyle+c[m].fontWeight,e.push(new H(l,h))):e.push(new H(l))}a(e)}else setTimeout(function(){b()},50)}var c=this,d=c.a.projectId,e=c.a.version;if(d){var f=c.c.m;B(this.c,ta(c,d,e),function(e){e?a([]):(f["__MonotypeConfiguration__"+d]=function(){return c.a},b())}).id="__MonotypeAPIScript__"+
	d}else a([])};function ua(a,b){this.c=a;this.a=b}ua.prototype.load=function(a){var b,c,d=this.a.urls||[],e=this.a.families||[],f=this.a.testStrings||{},g=new C;b=0;for(c=d.length;b<c;b++)A(this.c,d[b],D(g));var k=[];b=0;for(c=e.length;b<c;b++)if(d=e[b].split(":"),d[1])for(var h=d[1].split(","),m=0;m<h.length;m+=1)k.push(new H(d[0],h[m]));else k.push(new H(d[0]));F(g,function(){a(k,f)})};function va(a,b,c){a?this.c=a:this.c=b+wa;this.a=[];this.f=[];this.g=c||""}var wa="//fonts.googleapis.com/css";function xa(a,b){for(var c=b.length,d=0;d<c;d++){var e=b[d].split(":");3==e.length&&a.f.push(e.pop());var f="";2==e.length&&""!=e[1]&&(f=":");a.a.push(e.join(f))}}
	function ya(a){if(0==a.a.length)throw Error("No fonts to load!");if(-1!=a.c.indexOf("kit="))return a.c;for(var b=a.a.length,c=[],d=0;d<b;d++)c.push(a.a[d].replace(/ /g,"+"));b=a.c+"?family="+c.join("%7C");0<a.f.length&&(b+="&subset="+a.f.join(","));0<a.g.length&&(b+="&text="+encodeURIComponent(a.g));return b};function za(a){this.f=a;this.a=[];this.c={}}
	var Aa={latin:"BESbswy","latin-ext":"\u00e7\u00f6\u00fc\u011f\u015f",cyrillic:"\u0439\u044f\u0416",greek:"\u03b1\u03b2\u03a3",khmer:"\u1780\u1781\u1782",Hanuman:"\u1780\u1781\u1782"},Ba={thin:"1",extralight:"2","extra-light":"2",ultralight:"2","ultra-light":"2",light:"3",regular:"4",book:"4",medium:"5","semi-bold":"6",semibold:"6","demi-bold":"6",demibold:"6",bold:"7","extra-bold":"8",extrabold:"8","ultra-bold":"8",ultrabold:"8",black:"9",heavy:"9",l:"3",r:"4",b:"7"},Ca={i:"i",italic:"i",n:"n",normal:"n"},
	Da=/^(thin|(?:(?:extra|ultra)-?)?light|regular|book|medium|(?:(?:semi|demi|extra|ultra)-?)?bold|black|heavy|l|r|b|[1-9]00)?(n|i|normal|italic)?$/;
	function Ea(a){for(var b=a.f.length,c=0;c<b;c++){var d=a.f[c].split(":"),e=d[0].replace(/\+/g," "),f=["n4"];if(2<=d.length){var g;var k=d[1];g=[];if(k)for(var k=k.split(","),h=k.length,m=0;m<h;m++){var l;l=k[m];if(l.match(/^[\w-]+$/)){var n=Da.exec(l.toLowerCase());if(null==n)l="";else{l=n[2];l=null==l||""==l?"n":Ca[l];n=n[1];if(null==n||""==n)n="4";else var r=Ba[n],n=r?r:isNaN(n)?"4":n.substr(0,1);l=[l,n].join("")}}else l="";l&&g.push(l)}0<g.length&&(f=g);3==d.length&&(d=d[2],g=[],d=d?d.split(","):
	g,0<d.length&&(d=Aa[d[0]])&&(a.c[e]=d))}a.c[e]||(d=Aa[e])&&(a.c[e]=d);for(d=0;d<f.length;d+=1)a.a.push(new H(e,f[d]))}};function Fa(a,b){this.c=a;this.a=b}var Ga={Arimo:!0,Cousine:!0,Tinos:!0};Fa.prototype.load=function(a){var b=new C,c=this.c,d=new va(this.a.api,z(c),this.a.text),e=this.a.families;xa(d,e);var f=new za(e);Ea(f);A(c,ya(d),D(b));F(b,function(){a(f.a,f.c,Ga)})};function Ha(a,b){this.c=a;this.a=b}Ha.prototype.load=function(a){var b=this.a.id,c=this.c.m;b?B(this.c,(this.a.api||"https://use.typekit.net")+"/"+b+".js",function(b){if(b)a([]);else if(c.Typekit&&c.Typekit.config&&c.Typekit.config.fn){b=c.Typekit.config.fn;for(var e=[],f=0;f<b.length;f+=2)for(var g=b[f],k=b[f+1],h=0;h<k.length;h++)e.push(new H(g,k[h]));try{c.Typekit.load({events:!1,classes:!1,async:!0})}catch(m){}a(e)}},2E3):a([])};function Ia(a,b){this.c=a;this.f=b;this.a=[]}Ia.prototype.load=function(a){var b=this.f.id,c=this.c.m,d=this;b?(c.__webfontfontdeckmodule__||(c.__webfontfontdeckmodule__={}),c.__webfontfontdeckmodule__[b]=function(b,c){for(var g=0,k=c.fonts.length;g<k;++g){var h=c.fonts[g];d.a.push(new H(h.name,ga("font-weight:"+h.weight+";font-style:"+h.style)))}a(d.a)},B(this.c,z(this.c)+(this.f.api||"//f.fontdeck.com/s/css/js/")+ea(this.c)+"/"+b+".js",function(b){b&&a([])})):a([])};var Y=new pa(window);Y.a.c.custom=function(a,b){return new ua(b,a)};Y.a.c.fontdeck=function(a,b){return new Ia(b,a)};Y.a.c.monotype=function(a,b){return new sa(b,a)};Y.a.c.typekit=function(a,b){return new Ha(b,a)};Y.a.c.google=function(a,b){return new Fa(b,a)};var Z={load:p(Y.load,Y)}; true?!(__WEBPACK_AMD_DEFINE_RESULT__ = function(){return Z}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)):"undefined"!==typeof module&&module.exports?module.exports=Z:(window.WebFont=Z,window.WebFontConfig&&Y.load(window.WebFontConfig));}());


/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Observable_1 = __webpack_require__(4);
	var debounceTime_1 = __webpack_require__(19);
	Observable_1.Observable.prototype.debounceTime = debounceTime_1.debounceTime;
	//# sourceMappingURL=debounceTime.js.map

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var root_1 = __webpack_require__(5);
	var toSubscriber_1 = __webpack_require__(7);
	var observable_1 = __webpack_require__(18);
	/**
	 * A representation of any set of values over any amount of time. This the most basic building block
	 * of RxJS.
	 *
	 * @class Observable<T>
	 */
	var Observable = (function () {
	    /**
	     * @constructor
	     * @param {Function} subscribe the function that is  called when the Observable is
	     * initially subscribed to. This function is given a Subscriber, to which new values
	     * can be `next`ed, or an `error` method can be called to raise an error, or
	     * `complete` can be called to notify of a successful completion.
	     */
	    function Observable(subscribe) {
	        this._isScalar = false;
	        if (subscribe) {
	            this._subscribe = subscribe;
	        }
	    }
	    /**
	     * Creates a new Observable, with this Observable as the source, and the passed
	     * operator defined as the new observable's operator.
	     * @method lift
	     * @param {Operator} operator the operator defining the operation to take on the observable
	     * @return {Observable} a new observable with the Operator applied
	     */
	    Observable.prototype.lift = function (operator) {
	        var observable = new Observable();
	        observable.source = this;
	        observable.operator = operator;
	        return observable;
	    };
	    /**
	     * Registers handlers for handling emitted values, error and completions from the observable, and
	     *  executes the observable's subscriber function, which will take action to set up the underlying data stream
	     * @method subscribe
	     * @param {PartialObserver|Function} observerOrNext (optional) either an observer defining all functions to be called,
	     *  or the first of three possible handlers, which is the handler for each value emitted from the observable.
	     * @param {Function} error (optional) a handler for a terminal event resulting from an error. If no error handler is provided,
	     *  the error will be thrown as unhandled
	     * @param {Function} complete (optional) a handler for a terminal event resulting from successful completion.
	     * @return {ISubscription} a subscription reference to the registered handlers
	     */
	    Observable.prototype.subscribe = function (observerOrNext, error, complete) {
	        var operator = this.operator;
	        var sink = toSubscriber_1.toSubscriber(observerOrNext, error, complete);
	        if (operator) {
	            operator.call(sink, this);
	        }
	        else {
	            sink.add(this._subscribe(sink));
	        }
	        if (sink.syncErrorThrowable) {
	            sink.syncErrorThrowable = false;
	            if (sink.syncErrorThrown) {
	                throw sink.syncErrorValue;
	            }
	        }
	        return sink;
	    };
	    /**
	     * @method forEach
	     * @param {Function} next a handler for each value emitted by the observable
	     * @param {PromiseConstructor} [PromiseCtor] a constructor function used to instantiate the Promise
	     * @return {Promise} a promise that either resolves on observable completion or
	     *  rejects with the handled error
	     */
	    Observable.prototype.forEach = function (next, PromiseCtor) {
	        var _this = this;
	        if (!PromiseCtor) {
	            if (root_1.root.Rx && root_1.root.Rx.config && root_1.root.Rx.config.Promise) {
	                PromiseCtor = root_1.root.Rx.config.Promise;
	            }
	            else if (root_1.root.Promise) {
	                PromiseCtor = root_1.root.Promise;
	            }
	        }
	        if (!PromiseCtor) {
	            throw new Error('no Promise impl found');
	        }
	        return new PromiseCtor(function (resolve, reject) {
	            var subscription = _this.subscribe(function (value) {
	                if (subscription) {
	                    // if there is a subscription, then we can surmise
	                    // the next handling is asynchronous. Any errors thrown
	                    // need to be rejected explicitly and unsubscribe must be
	                    // called manually
	                    try {
	                        next(value);
	                    }
	                    catch (err) {
	                        reject(err);
	                        subscription.unsubscribe();
	                    }
	                }
	                else {
	                    // if there is NO subscription, then we're getting a nexted
	                    // value synchronously during subscription. We can just call it.
	                    // If it errors, Observable's `subscribe` will ensure the
	                    // unsubscription logic is called, then synchronously rethrow the error.
	                    // After that, Promise will trap the error and send it
	                    // down the rejection path.
	                    next(value);
	                }
	            }, reject, resolve);
	        });
	    };
	    Observable.prototype._subscribe = function (subscriber) {
	        return this.source.subscribe(subscriber);
	    };
	    /**
	     * An interop point defined by the es7-observable spec https://github.com/zenparsing/es-observable
	     * @method Symbol.observable
	     * @return {Observable} this instance of the observable
	     */
	    Observable.prototype[observable_1.$$observable] = function () {
	        return this;
	    };
	    // HACK: Since TypeScript inherits static properties too, we have to
	    // fight against TypeScript here so Subject can have a different static create signature
	    /**
	     * Creates a new cold Observable by calling the Observable constructor
	     * @static true
	     * @owner Observable
	     * @method create
	     * @param {Function} subscribe? the subscriber function to be passed to the Observable constructor
	     * @return {Observable} a new cold observable
	     */
	    Observable.create = function (subscribe) {
	        return new Observable(subscribe);
	    };
	    return Observable;
	}());
	exports.Observable = Observable;
	//# sourceMappingURL=Observable.js.map

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(module, global) {"use strict";
	var objectTypes = {
	    'boolean': false,
	    'function': true,
	    'object': true,
	    'number': false,
	    'string': false,
	    'undefined': false
	};
	exports.root = (objectTypes[typeof self] && self) || (objectTypes[typeof window] && window);
	/* tslint:disable:no-unused-variable */
	var freeExports = objectTypes[typeof exports] && exports && !exports.nodeType && exports;
	var freeModule = objectTypes[typeof module] && module && !module.nodeType && module;
	var freeGlobal = objectTypes[typeof global] && global;
	if (freeGlobal && (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal)) {
	    exports.root = freeGlobal;
	}
	//# sourceMappingURL=root.js.map
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(6)(module), (function() { return this; }())))

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = function(module) {
		if(!module.webpackPolyfill) {
			module.deprecate = function() {};
			module.paths = [];
			// module.parent = undefined by default
			module.children = [];
			module.webpackPolyfill = 1;
		}
		return module;
	}


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Subscriber_1 = __webpack_require__(8);
	var rxSubscriber_1 = __webpack_require__(17);
	function toSubscriber(nextOrObserver, error, complete) {
	    if (nextOrObserver) {
	        if (nextOrObserver instanceof Subscriber_1.Subscriber) {
	            return nextOrObserver;
	        }
	        if (nextOrObserver[rxSubscriber_1.$$rxSubscriber]) {
	            return nextOrObserver[rxSubscriber_1.$$rxSubscriber]();
	        }
	    }
	    if (!nextOrObserver && !error && !complete) {
	        return new Subscriber_1.Subscriber();
	    }
	    return new Subscriber_1.Subscriber(nextOrObserver, error, complete);
	}
	exports.toSubscriber = toSubscriber;
	//# sourceMappingURL=toSubscriber.js.map

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var isFunction_1 = __webpack_require__(9);
	var Subscription_1 = __webpack_require__(10);
	var Observer_1 = __webpack_require__(16);
	var rxSubscriber_1 = __webpack_require__(17);
	/**
	 * Implements the {@link Observer} interface and extends the
	 * {@link Subscription} class. While the {@link Observer} is the public API for
	 * consuming the values of an {@link Observable}, all Observers get converted to
	 * a Subscriber, in order to provide Subscription-like capabilities such as
	 * `unsubscribe`. Subscriber is a common type in RxJS, and crucial for
	 * implementing operators, but it is rarely used as a public API.
	 *
	 * @class Subscriber<T>
	 */
	var Subscriber = (function (_super) {
	    __extends(Subscriber, _super);
	    /**
	     * @param {Observer|function(value: T): void} [destinationOrNext] A partially
	     * defined Observer or a `next` callback function.
	     * @param {function(e: ?any): void} [error] The `error` callback of an
	     * Observer.
	     * @param {function(): void} [complete] The `complete` callback of an
	     * Observer.
	     */
	    function Subscriber(destinationOrNext, error, complete) {
	        _super.call(this);
	        this.syncErrorValue = null;
	        this.syncErrorThrown = false;
	        this.syncErrorThrowable = false;
	        this.isStopped = false;
	        switch (arguments.length) {
	            case 0:
	                this.destination = Observer_1.empty;
	                break;
	            case 1:
	                if (!destinationOrNext) {
	                    this.destination = Observer_1.empty;
	                    break;
	                }
	                if (typeof destinationOrNext === 'object') {
	                    if (destinationOrNext instanceof Subscriber) {
	                        this.destination = destinationOrNext;
	                        this.destination.add(this);
	                    }
	                    else {
	                        this.syncErrorThrowable = true;
	                        this.destination = new SafeSubscriber(this, destinationOrNext);
	                    }
	                    break;
	                }
	            default:
	                this.syncErrorThrowable = true;
	                this.destination = new SafeSubscriber(this, destinationOrNext, error, complete);
	                break;
	        }
	    }
	    Subscriber.prototype[rxSubscriber_1.$$rxSubscriber] = function () { return this; };
	    /**
	     * A static factory for a Subscriber, given a (potentially partial) definition
	     * of an Observer.
	     * @param {function(x: ?T): void} [next] The `next` callback of an Observer.
	     * @param {function(e: ?any): void} [error] The `error` callback of an
	     * Observer.
	     * @param {function(): void} [complete] The `complete` callback of an
	     * Observer.
	     * @return {Subscriber<T>} A Subscriber wrapping the (partially defined)
	     * Observer represented by the given arguments.
	     */
	    Subscriber.create = function (next, error, complete) {
	        var subscriber = new Subscriber(next, error, complete);
	        subscriber.syncErrorThrowable = false;
	        return subscriber;
	    };
	    /**
	     * The {@link Observer} callback to receive notifications of type `next` from
	     * the Observable, with a value. The Observable may call this method 0 or more
	     * times.
	     * @param {T} [value] The `next` value.
	     * @return {void}
	     */
	    Subscriber.prototype.next = function (value) {
	        if (!this.isStopped) {
	            this._next(value);
	        }
	    };
	    /**
	     * The {@link Observer} callback to receive notifications of type `error` from
	     * the Observable, with an attached {@link Error}. Notifies the Observer that
	     * the Observable has experienced an error condition.
	     * @param {any} [err] The `error` exception.
	     * @return {void}
	     */
	    Subscriber.prototype.error = function (err) {
	        if (!this.isStopped) {
	            this.isStopped = true;
	            this._error(err);
	        }
	    };
	    /**
	     * The {@link Observer} callback to receive a valueless notification of type
	     * `complete` from the Observable. Notifies the Observer that the Observable
	     * has finished sending push-based notifications.
	     * @return {void}
	     */
	    Subscriber.prototype.complete = function () {
	        if (!this.isStopped) {
	            this.isStopped = true;
	            this._complete();
	        }
	    };
	    Subscriber.prototype.unsubscribe = function () {
	        if (this.closed) {
	            return;
	        }
	        this.isStopped = true;
	        _super.prototype.unsubscribe.call(this);
	    };
	    Subscriber.prototype._next = function (value) {
	        this.destination.next(value);
	    };
	    Subscriber.prototype._error = function (err) {
	        this.destination.error(err);
	        this.unsubscribe();
	    };
	    Subscriber.prototype._complete = function () {
	        this.destination.complete();
	        this.unsubscribe();
	    };
	    return Subscriber;
	}(Subscription_1.Subscription));
	exports.Subscriber = Subscriber;
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var SafeSubscriber = (function (_super) {
	    __extends(SafeSubscriber, _super);
	    function SafeSubscriber(_parent, observerOrNext, error, complete) {
	        _super.call(this);
	        this._parent = _parent;
	        var next;
	        var context = this;
	        if (isFunction_1.isFunction(observerOrNext)) {
	            next = observerOrNext;
	        }
	        else if (observerOrNext) {
	            context = observerOrNext;
	            next = observerOrNext.next;
	            error = observerOrNext.error;
	            complete = observerOrNext.complete;
	            if (isFunction_1.isFunction(context.unsubscribe)) {
	                this.add(context.unsubscribe.bind(context));
	            }
	            context.unsubscribe = this.unsubscribe.bind(this);
	        }
	        this._context = context;
	        this._next = next;
	        this._error = error;
	        this._complete = complete;
	    }
	    SafeSubscriber.prototype.next = function (value) {
	        if (!this.isStopped && this._next) {
	            var _parent = this._parent;
	            if (!_parent.syncErrorThrowable) {
	                this.__tryOrUnsub(this._next, value);
	            }
	            else if (this.__tryOrSetError(_parent, this._next, value)) {
	                this.unsubscribe();
	            }
	        }
	    };
	    SafeSubscriber.prototype.error = function (err) {
	        if (!this.isStopped) {
	            var _parent = this._parent;
	            if (this._error) {
	                if (!_parent.syncErrorThrowable) {
	                    this.__tryOrUnsub(this._error, err);
	                    this.unsubscribe();
	                }
	                else {
	                    this.__tryOrSetError(_parent, this._error, err);
	                    this.unsubscribe();
	                }
	            }
	            else if (!_parent.syncErrorThrowable) {
	                this.unsubscribe();
	                throw err;
	            }
	            else {
	                _parent.syncErrorValue = err;
	                _parent.syncErrorThrown = true;
	                this.unsubscribe();
	            }
	        }
	    };
	    SafeSubscriber.prototype.complete = function () {
	        if (!this.isStopped) {
	            var _parent = this._parent;
	            if (this._complete) {
	                if (!_parent.syncErrorThrowable) {
	                    this.__tryOrUnsub(this._complete);
	                    this.unsubscribe();
	                }
	                else {
	                    this.__tryOrSetError(_parent, this._complete);
	                    this.unsubscribe();
	                }
	            }
	            else {
	                this.unsubscribe();
	            }
	        }
	    };
	    SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
	        try {
	            fn.call(this._context, value);
	        }
	        catch (err) {
	            this.unsubscribe();
	            throw err;
	        }
	    };
	    SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
	        try {
	            fn.call(this._context, value);
	        }
	        catch (err) {
	            parent.syncErrorValue = err;
	            parent.syncErrorThrown = true;
	            return true;
	        }
	        return false;
	    };
	    SafeSubscriber.prototype._unsubscribe = function () {
	        var _parent = this._parent;
	        this._context = null;
	        this._parent = null;
	        _parent.unsubscribe();
	    };
	    return SafeSubscriber;
	}(Subscriber));
	//# sourceMappingURL=Subscriber.js.map

/***/ },
/* 9 */
/***/ function(module, exports) {

	"use strict";
	function isFunction(x) {
	    return typeof x === 'function';
	}
	exports.isFunction = isFunction;
	//# sourceMappingURL=isFunction.js.map

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var isArray_1 = __webpack_require__(11);
	var isObject_1 = __webpack_require__(12);
	var isFunction_1 = __webpack_require__(9);
	var tryCatch_1 = __webpack_require__(13);
	var errorObject_1 = __webpack_require__(14);
	var UnsubscriptionError_1 = __webpack_require__(15);
	/**
	 * Represents a disposable resource, such as the execution of an Observable. A
	 * Subscription has one important method, `unsubscribe`, that takes no argument
	 * and just disposes the resource held by the subscription.
	 *
	 * Additionally, subscriptions may be grouped together through the `add()`
	 * method, which will attach a child Subscription to the current Subscription.
	 * When a Subscription is unsubscribed, all its children (and its grandchildren)
	 * will be unsubscribed as well.
	 *
	 * @class Subscription
	 */
	var Subscription = (function () {
	    /**
	     * @param {function(): void} [unsubscribe] A function describing how to
	     * perform the disposal of resources when the `unsubscribe` method is called.
	     */
	    function Subscription(unsubscribe) {
	        /**
	         * A flag to indicate whether this Subscription has already been unsubscribed.
	         * @type {boolean}
	         */
	        this.closed = false;
	        if (unsubscribe) {
	            this._unsubscribe = unsubscribe;
	        }
	    }
	    /**
	     * Disposes the resources held by the subscription. May, for instance, cancel
	     * an ongoing Observable execution or cancel any other type of work that
	     * started when the Subscription was created.
	     * @return {void}
	     */
	    Subscription.prototype.unsubscribe = function () {
	        var hasErrors = false;
	        var errors;
	        if (this.closed) {
	            return;
	        }
	        this.closed = true;
	        var _a = this, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
	        this._subscriptions = null;
	        if (isFunction_1.isFunction(_unsubscribe)) {
	            var trial = tryCatch_1.tryCatch(_unsubscribe).call(this);
	            if (trial === errorObject_1.errorObject) {
	                hasErrors = true;
	                (errors = errors || []).push(errorObject_1.errorObject.e);
	            }
	        }
	        if (isArray_1.isArray(_subscriptions)) {
	            var index = -1;
	            var len = _subscriptions.length;
	            while (++index < len) {
	                var sub = _subscriptions[index];
	                if (isObject_1.isObject(sub)) {
	                    var trial = tryCatch_1.tryCatch(sub.unsubscribe).call(sub);
	                    if (trial === errorObject_1.errorObject) {
	                        hasErrors = true;
	                        errors = errors || [];
	                        var err = errorObject_1.errorObject.e;
	                        if (err instanceof UnsubscriptionError_1.UnsubscriptionError) {
	                            errors = errors.concat(err.errors);
	                        }
	                        else {
	                            errors.push(err);
	                        }
	                    }
	                }
	            }
	        }
	        if (hasErrors) {
	            throw new UnsubscriptionError_1.UnsubscriptionError(errors);
	        }
	    };
	    /**
	     * Adds a tear down to be called during the unsubscribe() of this
	     * Subscription.
	     *
	     * If the tear down being added is a subscription that is already
	     * unsubscribed, is the same reference `add` is being called on, or is
	     * `Subscription.EMPTY`, it will not be added.
	     *
	     * If this subscription is already in an `closed` state, the passed
	     * tear down logic will be executed immediately.
	     *
	     * @param {TeardownLogic} teardown The additional logic to execute on
	     * teardown.
	     * @return {Subscription} Returns the Subscription used or created to be
	     * added to the inner subscriptions list. This Subscription can be used with
	     * `remove()` to remove the passed teardown logic from the inner subscriptions
	     * list.
	     */
	    Subscription.prototype.add = function (teardown) {
	        if (!teardown || (teardown === Subscription.EMPTY)) {
	            return Subscription.EMPTY;
	        }
	        if (teardown === this) {
	            return this;
	        }
	        var sub = teardown;
	        switch (typeof teardown) {
	            case 'function':
	                sub = new Subscription(teardown);
	            case 'object':
	                if (sub.closed || typeof sub.unsubscribe !== 'function') {
	                    break;
	                }
	                else if (this.closed) {
	                    sub.unsubscribe();
	                }
	                else {
	                    (this._subscriptions || (this._subscriptions = [])).push(sub);
	                }
	                break;
	            default:
	                throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
	        }
	        return sub;
	    };
	    /**
	     * Removes a Subscription from the internal list of subscriptions that will
	     * unsubscribe during the unsubscribe process of this Subscription.
	     * @param {Subscription} subscription The subscription to remove.
	     * @return {void}
	     */
	    Subscription.prototype.remove = function (subscription) {
	        // HACK: This might be redundant because of the logic in `add()`
	        if (subscription == null || (subscription === this) || (subscription === Subscription.EMPTY)) {
	            return;
	        }
	        var subscriptions = this._subscriptions;
	        if (subscriptions) {
	            var subscriptionIndex = subscriptions.indexOf(subscription);
	            if (subscriptionIndex !== -1) {
	                subscriptions.splice(subscriptionIndex, 1);
	            }
	        }
	    };
	    Subscription.EMPTY = (function (empty) {
	        empty.closed = true;
	        return empty;
	    }(new Subscription()));
	    return Subscription;
	}());
	exports.Subscription = Subscription;
	//# sourceMappingURL=Subscription.js.map

/***/ },
/* 11 */
/***/ function(module, exports) {

	"use strict";
	exports.isArray = Array.isArray || (function (x) { return x && typeof x.length === 'number'; });
	//# sourceMappingURL=isArray.js.map

/***/ },
/* 12 */
/***/ function(module, exports) {

	"use strict";
	function isObject(x) {
	    return x != null && typeof x === 'object';
	}
	exports.isObject = isObject;
	//# sourceMappingURL=isObject.js.map

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var errorObject_1 = __webpack_require__(14);
	var tryCatchTarget;
	function tryCatcher() {
	    try {
	        return tryCatchTarget.apply(this, arguments);
	    }
	    catch (e) {
	        errorObject_1.errorObject.e = e;
	        return errorObject_1.errorObject;
	    }
	}
	function tryCatch(fn) {
	    tryCatchTarget = fn;
	    return tryCatcher;
	}
	exports.tryCatch = tryCatch;
	;
	//# sourceMappingURL=tryCatch.js.map

/***/ },
/* 14 */
/***/ function(module, exports) {

	"use strict";
	// typeof any so that it we don't have to cast when comparing a result to the error object
	exports.errorObject = { e: {} };
	//# sourceMappingURL=errorObject.js.map

/***/ },
/* 15 */
/***/ function(module, exports) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	/**
	 * An error thrown when one or more errors have occurred during the
	 * `unsubscribe` of a {@link Subscription}.
	 */
	var UnsubscriptionError = (function (_super) {
	    __extends(UnsubscriptionError, _super);
	    function UnsubscriptionError(errors) {
	        _super.call(this);
	        this.errors = errors;
	        var err = Error.call(this, errors ?
	            errors.length + " errors occurred during unsubscription:\n  " + errors.map(function (err, i) { return ((i + 1) + ") " + err.toString()); }).join('\n  ') : '');
	        this.name = err.name = 'UnsubscriptionError';
	        this.stack = err.stack;
	        this.message = err.message;
	    }
	    return UnsubscriptionError;
	}(Error));
	exports.UnsubscriptionError = UnsubscriptionError;
	//# sourceMappingURL=UnsubscriptionError.js.map

/***/ },
/* 16 */
/***/ function(module, exports) {

	"use strict";
	exports.empty = {
	    closed: true,
	    next: function (value) { },
	    error: function (err) { throw err; },
	    complete: function () { }
	};
	//# sourceMappingURL=Observer.js.map

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var root_1 = __webpack_require__(5);
	var Symbol = root_1.root.Symbol;
	exports.$$rxSubscriber = (typeof Symbol === 'function' && typeof Symbol.for === 'function') ?
	    Symbol.for('rxSubscriber') : '@@rxSubscriber';
	//# sourceMappingURL=rxSubscriber.js.map

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var root_1 = __webpack_require__(5);
	function getSymbolObservable(context) {
	    var $$observable;
	    var Symbol = context.Symbol;
	    if (typeof Symbol === 'function') {
	        if (Symbol.observable) {
	            $$observable = Symbol.observable;
	        }
	        else {
	            $$observable = Symbol('observable');
	            Symbol.observable = $$observable;
	        }
	    }
	    else {
	        $$observable = '@@observable';
	    }
	    return $$observable;
	}
	exports.getSymbolObservable = getSymbolObservable;
	exports.$$observable = getSymbolObservable(root_1.root);
	//# sourceMappingURL=observable.js.map

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscriber_1 = __webpack_require__(8);
	var async_1 = __webpack_require__(20);
	/**
	 * Emits a value from the source Observable only after a particular time span
	 * has passed without another source emission.
	 *
	 * <span class="informal">It's like {@link delay}, but passes only the most
	 * recent value from each burst of emissions.</span>
	 *
	 * <img src="./img/debounceTime.png" width="100%">
	 *
	 * `debounceTime` delays values emitted by the source Observable, but drops
	 * previous pending delayed emissions if a new value arrives on the source
	 * Observable. This operator keeps track of the most recent value from the
	 * source Observable, and emits that only when `dueTime` enough time has passed
	 * without any other value appearing on the source Observable. If a new value
	 * appears before `dueTime` silence occurs, the previous value will be dropped
	 * and will not be emitted on the output Observable.
	 *
	 * This is a rate-limiting operator, because it is impossible for more than one
	 * value to be emitted in any time window of duration `dueTime`, but it is also
	 * a delay-like operator since output emissions do not occur at the same time as
	 * they did on the source Observable. Optionally takes a {@link Scheduler} for
	 * managing timers.
	 *
	 * @example <caption>Emit the most recent click after a burst of clicks</caption>
	 * var clicks = Rx.Observable.fromEvent(document, 'click');
	 * var result = clicks.debounceTime(1000);
	 * result.subscribe(x => console.log(x));
	 *
	 * @see {@link auditTime}
	 * @see {@link debounce}
	 * @see {@link delay}
	 * @see {@link sampleTime}
	 * @see {@link throttleTime}
	 *
	 * @param {number} dueTime The timeout duration in milliseconds (or the time
	 * unit determined internally by the optional `scheduler`) for the window of
	 * time required to wait for emission silence before emitting the most recent
	 * source value.
	 * @param {Scheduler} [scheduler=async] The {@link Scheduler} to use for
	 * managing the timers that handle the timeout for each value.
	 * @return {Observable} An Observable that delays the emissions of the source
	 * Observable by the specified `dueTime`, and may drop some values if they occur
	 * too frequently.
	 * @method debounceTime
	 * @owner Observable
	 */
	function debounceTime(dueTime, scheduler) {
	    if (scheduler === void 0) { scheduler = async_1.async; }
	    return this.lift(new DebounceTimeOperator(dueTime, scheduler));
	}
	exports.debounceTime = debounceTime;
	var DebounceTimeOperator = (function () {
	    function DebounceTimeOperator(dueTime, scheduler) {
	        this.dueTime = dueTime;
	        this.scheduler = scheduler;
	    }
	    DebounceTimeOperator.prototype.call = function (subscriber, source) {
	        return source._subscribe(new DebounceTimeSubscriber(subscriber, this.dueTime, this.scheduler));
	    };
	    return DebounceTimeOperator;
	}());
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var DebounceTimeSubscriber = (function (_super) {
	    __extends(DebounceTimeSubscriber, _super);
	    function DebounceTimeSubscriber(destination, dueTime, scheduler) {
	        _super.call(this, destination);
	        this.dueTime = dueTime;
	        this.scheduler = scheduler;
	        this.debouncedSubscription = null;
	        this.lastValue = null;
	        this.hasValue = false;
	    }
	    DebounceTimeSubscriber.prototype._next = function (value) {
	        this.clearDebounce();
	        this.lastValue = value;
	        this.hasValue = true;
	        this.add(this.debouncedSubscription = this.scheduler.schedule(dispatchNext, this.dueTime, this));
	    };
	    DebounceTimeSubscriber.prototype._complete = function () {
	        this.debouncedNext();
	        this.destination.complete();
	    };
	    DebounceTimeSubscriber.prototype.debouncedNext = function () {
	        this.clearDebounce();
	        if (this.hasValue) {
	            this.destination.next(this.lastValue);
	            this.lastValue = null;
	            this.hasValue = false;
	        }
	    };
	    DebounceTimeSubscriber.prototype.clearDebounce = function () {
	        var debouncedSubscription = this.debouncedSubscription;
	        if (debouncedSubscription !== null) {
	            this.remove(debouncedSubscription);
	            debouncedSubscription.unsubscribe();
	            this.debouncedSubscription = null;
	        }
	    };
	    return DebounceTimeSubscriber;
	}(Subscriber_1.Subscriber));
	function dispatchNext(subscriber) {
	    subscriber.debouncedNext();
	}
	//# sourceMappingURL=debounceTime.js.map

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var AsyncAction_1 = __webpack_require__(21);
	var AsyncScheduler_1 = __webpack_require__(23);
	exports.async = new AsyncScheduler_1.AsyncScheduler(AsyncAction_1.AsyncAction);
	//# sourceMappingURL=async.js.map

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var root_1 = __webpack_require__(5);
	var Action_1 = __webpack_require__(22);
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var AsyncAction = (function (_super) {
	    __extends(AsyncAction, _super);
	    function AsyncAction(scheduler, work) {
	        _super.call(this, scheduler, work);
	        this.scheduler = scheduler;
	        this.work = work;
	        this.pending = false;
	    }
	    AsyncAction.prototype.schedule = function (state, delay) {
	        if (delay === void 0) { delay = 0; }
	        if (this.closed) {
	            return this;
	        }
	        // Always replace the current state with the new state.
	        this.state = state;
	        // Set the pending flag indicating that this action has been scheduled, or
	        // has recursively rescheduled itself.
	        this.pending = true;
	        var id = this.id;
	        var scheduler = this.scheduler;
	        //
	        // Important implementation note:
	        //
	        // Actions only execute once by default, unless rescheduled from within the
	        // scheduled callback. This allows us to implement single and repeat
	        // actions via the same code path, without adding API surface area, as well
	        // as mimic traditional recursion but across asynchronous boundaries.
	        //
	        // However, JS runtimes and timers distinguish between intervals achieved by
	        // serial `setTimeout` calls vs. a single `setInterval` call. An interval of
	        // serial `setTimeout` calls can be individually delayed, which delays
	        // scheduling the next `setTimeout`, and so on. `setInterval` attempts to
	        // guarantee the interval callback will be invoked more precisely to the
	        // interval period, regardless of load.
	        //
	        // Therefore, we use `setInterval` to schedule single and repeat actions.
	        // If the action reschedules itself with the same delay, the interval is not
	        // canceled. If the action doesn't reschedule, or reschedules with a
	        // different delay, the interval will be canceled after scheduled callback
	        // execution.
	        //
	        if (id != null) {
	            this.id = this.recycleAsyncId(scheduler, id, delay);
	        }
	        this.delay = delay;
	        // If this action has already an async Id, don't request a new one.
	        this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
	        return this;
	    };
	    AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
	        if (delay === void 0) { delay = 0; }
	        return root_1.root.setInterval(scheduler.flush.bind(scheduler, this), delay);
	    };
	    AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
	        if (delay === void 0) { delay = 0; }
	        // If this action is rescheduled with the same delay time, don't clear the interval id.
	        if (delay !== null && this.delay === delay) {
	            return id;
	        }
	        // Otherwise, if the action's delay time is different from the current delay,
	        // clear the interval id
	        return root_1.root.clearInterval(id) && undefined || undefined;
	    };
	    /**
	     * Immediately executes this action and the `work` it contains.
	     * @return {any}
	     */
	    AsyncAction.prototype.execute = function (state, delay) {
	        if (this.closed) {
	            return new Error('executing a cancelled action');
	        }
	        this.pending = false;
	        var error = this._execute(state, delay);
	        if (error) {
	            return error;
	        }
	        else if (this.pending === false && this.id != null) {
	            // Dequeue if the action didn't reschedule itself. Don't call
	            // unsubscribe(), because the action could reschedule later.
	            // For example:
	            // ```
	            // scheduler.schedule(function doWork(counter) {
	            //   /* ... I'm a busy worker bee ... */
	            //   var originalAction = this;
	            //   /* wait 100ms before rescheduling the action */
	            //   setTimeout(function () {
	            //     originalAction.schedule(counter + 1);
	            //   }, 100);
	            // }, 1000);
	            // ```
	            this.id = this.recycleAsyncId(this.scheduler, this.id, null);
	        }
	    };
	    AsyncAction.prototype._execute = function (state, delay) {
	        var errored = false;
	        var errorValue = undefined;
	        try {
	            this.work(state);
	        }
	        catch (e) {
	            errored = true;
	            errorValue = !!e && e || new Error(e);
	        }
	        if (errored) {
	            this.unsubscribe();
	            return errorValue;
	        }
	    };
	    AsyncAction.prototype._unsubscribe = function () {
	        var id = this.id;
	        var scheduler = this.scheduler;
	        var actions = scheduler.actions;
	        var index = actions.indexOf(this);
	        this.work = null;
	        this.delay = null;
	        this.state = null;
	        this.pending = false;
	        this.scheduler = null;
	        if (index !== -1) {
	            actions.splice(index, 1);
	        }
	        if (id != null) {
	            this.id = this.recycleAsyncId(scheduler, id, null);
	        }
	    };
	    return AsyncAction;
	}(Action_1.Action));
	exports.AsyncAction = AsyncAction;
	//# sourceMappingURL=AsyncAction.js.map

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscription_1 = __webpack_require__(10);
	/**
	 * A unit of work to be executed in a {@link Scheduler}. An action is typically
	 * created from within a Scheduler and an RxJS user does not need to concern
	 * themselves about creating and manipulating an Action.
	 *
	 * ```ts
	 * class Action<T> extends Subscription {
	 *   new (scheduler: Scheduler, work: (state?: T) => void);
	 *   schedule(state?: T, delay: number = 0): Subscription;
	 * }
	 * ```
	 *
	 * @class Action<T>
	 */
	var Action = (function (_super) {
	    __extends(Action, _super);
	    function Action(scheduler, work) {
	        _super.call(this);
	    }
	    /**
	     * Schedules this action on its parent Scheduler for execution. May be passed
	     * some context object, `state`. May happen at some point in the future,
	     * according to the `delay` parameter, if specified.
	     * @param {T} [state] Some contextual data that the `work` function uses when
	     * called by the Scheduler.
	     * @param {number} [delay] Time to wait before executing the work, where the
	     * time unit is implicit and defined by the Scheduler.
	     * @return {void}
	     */
	    Action.prototype.schedule = function (state, delay) {
	        if (delay === void 0) { delay = 0; }
	        return this;
	    };
	    return Action;
	}(Subscription_1.Subscription));
	exports.Action = Action;
	//# sourceMappingURL=Action.js.map

/***/ },
/* 23 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Scheduler_1 = __webpack_require__(24);
	var AsyncScheduler = (function (_super) {
	    __extends(AsyncScheduler, _super);
	    function AsyncScheduler() {
	        _super.apply(this, arguments);
	        this.actions = [];
	        /**
	         * A flag to indicate whether the Scheduler is currently executing a batch of
	         * queued actions.
	         * @type {boolean}
	         */
	        this.active = false;
	        /**
	         * An internal ID used to track the latest asynchronous task such as those
	         * coming from `setTimeout`, `setInterval`, `requestAnimationFrame`, and
	         * others.
	         * @type {any}
	         */
	        this.scheduled = undefined;
	    }
	    AsyncScheduler.prototype.flush = function (action) {
	        var actions = this.actions;
	        if (this.active) {
	            actions.push(action);
	            return;
	        }
	        var error;
	        this.active = true;
	        do {
	            if (error = action.execute(action.state, action.delay)) {
	                break;
	            }
	        } while (action = actions.shift()); // exhaust the scheduler queue
	        this.active = false;
	        if (error) {
	            while (action = actions.shift()) {
	                action.unsubscribe();
	            }
	            throw error;
	        }
	    };
	    return AsyncScheduler;
	}(Scheduler_1.Scheduler));
	exports.AsyncScheduler = AsyncScheduler;
	//# sourceMappingURL=AsyncScheduler.js.map

/***/ },
/* 24 */
/***/ function(module, exports) {

	"use strict";
	/**
	 * An execution context and a data structure to order tasks and schedule their
	 * execution. Provides a notion of (potentially virtual) time, through the
	 * `now()` getter method.
	 *
	 * Each unit of work in a Scheduler is called an {@link Action}.
	 *
	 * ```ts
	 * class Scheduler {
	 *   now(): number;
	 *   schedule(work, delay?, state?): Subscription;
	 * }
	 * ```
	 *
	 * @class Scheduler
	 */
	var Scheduler = (function () {
	    function Scheduler(SchedulerAction, now) {
	        if (now === void 0) { now = Scheduler.now; }
	        this.SchedulerAction = SchedulerAction;
	        this.now = now;
	    }
	    /**
	     * Schedules a function, `work`, for execution. May happen at some point in
	     * the future, according to the `delay` parameter, if specified. May be passed
	     * some context object, `state`, which will be passed to the `work` function.
	     *
	     * The given arguments will be processed an stored as an Action object in a
	     * queue of actions.
	     *
	     * @param {function(state: ?T): ?Subscription} work A function representing a
	     * task, or some unit of work to be executed by the Scheduler.
	     * @param {number} [delay] Time to wait before executing the work, where the
	     * time unit is implicit and defined by the Scheduler itself.
	     * @param {T} [state] Some contextual data that the `work` function uses when
	     * called by the Scheduler.
	     * @return {Subscription} A subscription in order to be able to unsubscribe
	     * the scheduled work.
	     */
	    Scheduler.prototype.schedule = function (work, delay, state) {
	        if (delay === void 0) { delay = 0; }
	        return new this.SchedulerAction(this, work).schedule(state, delay);
	    };
	    Scheduler.now = Date.now ? Date.now : function () { return +new Date(); };
	    return Scheduler;
	}());
	exports.Scheduler = Scheduler;
	//# sourceMappingURL=Scheduler.js.map

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Observable_1 = __webpack_require__(4);
	var distinctUntilChanged_1 = __webpack_require__(26);
	Observable_1.Observable.prototype.distinctUntilChanged = distinctUntilChanged_1.distinctUntilChanged;
	//# sourceMappingURL=distinctUntilChanged.js.map

/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscriber_1 = __webpack_require__(8);
	var tryCatch_1 = __webpack_require__(13);
	var errorObject_1 = __webpack_require__(14);
	/**
	 * Returns an Observable that emits all items emitted by the source Observable that are distinct by comparison from the previous item.
	 * If a comparator function is provided, then it will be called for each item to test for whether or not that value should be emitted.
	 * If a comparator function is not provided, an equality check is used by default.
	 * @param {function} [compare] optional comparison function called to test if an item is distinct from the previous item in the source.
	 * @return {Observable} an Observable that emits items from the source Observable with distinct values.
	 * @method distinctUntilChanged
	 * @owner Observable
	 */
	function distinctUntilChanged(compare, keySelector) {
	    return this.lift(new DistinctUntilChangedOperator(compare, keySelector));
	}
	exports.distinctUntilChanged = distinctUntilChanged;
	var DistinctUntilChangedOperator = (function () {
	    function DistinctUntilChangedOperator(compare, keySelector) {
	        this.compare = compare;
	        this.keySelector = keySelector;
	    }
	    DistinctUntilChangedOperator.prototype.call = function (subscriber, source) {
	        return source._subscribe(new DistinctUntilChangedSubscriber(subscriber, this.compare, this.keySelector));
	    };
	    return DistinctUntilChangedOperator;
	}());
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var DistinctUntilChangedSubscriber = (function (_super) {
	    __extends(DistinctUntilChangedSubscriber, _super);
	    function DistinctUntilChangedSubscriber(destination, compare, keySelector) {
	        _super.call(this, destination);
	        this.keySelector = keySelector;
	        this.hasKey = false;
	        if (typeof compare === 'function') {
	            this.compare = compare;
	        }
	    }
	    DistinctUntilChangedSubscriber.prototype.compare = function (x, y) {
	        return x === y;
	    };
	    DistinctUntilChangedSubscriber.prototype._next = function (value) {
	        var keySelector = this.keySelector;
	        var key = value;
	        if (keySelector) {
	            key = tryCatch_1.tryCatch(this.keySelector)(value);
	            if (key === errorObject_1.errorObject) {
	                return this.destination.error(errorObject_1.errorObject.e);
	            }
	        }
	        var result = false;
	        if (this.hasKey) {
	            result = tryCatch_1.tryCatch(this.compare)(this.key, key);
	            if (result === errorObject_1.errorObject) {
	                return this.destination.error(errorObject_1.errorObject.e);
	            }
	        }
	        else {
	            this.hasKey = true;
	        }
	        if (Boolean(result) === false) {
	            this.key = key;
	            this.destination.next(value);
	        }
	    };
	    return DistinctUntilChangedSubscriber;
	}(Subscriber_1.Subscriber));
	//# sourceMappingURL=distinctUntilChanged.js.map

/***/ },
/* 27 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_27__;

/***/ },
/* 28 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_28__;

/***/ },
/* 29 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_29__;

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	(function webpackUniversalModuleDefinition(root, factory) {
		if(true)
			module.exports = factory(__webpack_require__(28), __webpack_require__(31));
		else if(typeof define === 'function' && define.amd)
			define("angular2-perfect-scrollbar", ["@angular/core", "@angular/common"], factory);
		else if(typeof exports === 'object')
			exports["angular2-perfect-scrollbar"] = factory(require("@angular/core"), require("@angular/common"));
		else
			root["angular2-perfect-scrollbar"] = factory(root["@angular/core"], root["@angular/common"]);
	})(this, function(__WEBPACK_EXTERNAL_MODULE_23__, __WEBPACK_EXTERNAL_MODULE_27__) {
	return /******/ (function(modules) { // webpackBootstrap
	/******/ 	// The module cache
	/******/ 	var installedModules = {};

	/******/ 	// The require function
	/******/ 	function __webpack_require__(moduleId) {

	/******/ 		// Check if module is in cache
	/******/ 		if(installedModules[moduleId])
	/******/ 			return installedModules[moduleId].exports;

	/******/ 		// Create a new module (and put it into the cache)
	/******/ 		var module = installedModules[moduleId] = {
	/******/ 			exports: {},
	/******/ 			id: moduleId,
	/******/ 			loaded: false
	/******/ 		};

	/******/ 		// Execute the module function
	/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

	/******/ 		// Flag the module as loaded
	/******/ 		module.loaded = true;

	/******/ 		// Return the exports of the module
	/******/ 		return module.exports;
	/******/ 	}


	/******/ 	// expose the modules object (__webpack_modules__)
	/******/ 	__webpack_require__.m = modules;

	/******/ 	// expose the module cache
	/******/ 	__webpack_require__.c = installedModules;

	/******/ 	// __webpack_public_path__
	/******/ 	__webpack_require__.p = "";

	/******/ 	// Load entry module and return exports
	/******/ 	return __webpack_require__(0);
	/******/ })
	/************************************************************************/
	/******/ ([
	/* 0 */
	/***/ function(module, exports, __webpack_require__) {

		"use strict";
		function __export(m) {
		    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
		}
		__export(__webpack_require__(1));
		__export(__webpack_require__(24));
		__export(__webpack_require__(26));
		

	/***/ },
	/* 1 */
	/***/ function(module, exports, __webpack_require__) {

		"use strict";
		var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
		    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
		    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
		    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
		    return c > 3 && r && Object.defineProperty(target, key, r), r;
		};
		var __metadata = (this && this.__metadata) || function (k, v) {
		    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
		};
		var __param = (this && this.__param) || function (paramIndex, decorator) {
		    return function (target, key) { decorator(target, key, paramIndex); }
		};
		var Ps = __webpack_require__(2);
		var core_1 = __webpack_require__(23);
		var perfect_scrollbar_config_1 = __webpack_require__(24);
		var PerfectScrollbarComponent = (function () {
		    function PerfectScrollbarComponent(elementRef, defaults) {
		        this.elementRef = elementRef;
		        this.defaults = defaults;
		    }
		    PerfectScrollbarComponent.prototype.ngDoCheck = function () {
		        var width = this.elementRef.nativeElement.offsetWidth;
		        var height = this.elementRef.nativeElement.offsetHeight;
		        if (width !== this.width || height !== this.height) {
		            this.width = width;
		            this.height = height;
		            Ps.update(this.elementRef.nativeElement);
		        }
		    };
		    PerfectScrollbarComponent.prototype.ngOnDestroy = function () {
		        Ps.destroy(this.elementRef.nativeElement);
		    };
		    PerfectScrollbarComponent.prototype.ngAfterViewInit = function () {
		        var config = new perfect_scrollbar_config_1.PerfectScrollbarConfig(this.defaults);
		        config.assign(this.config);
		        Ps.initialize(this.elementRef.nativeElement, config);
		    };
		    PerfectScrollbarComponent.prototype.update = function () {
		        Ps.update(this.elementRef.nativeElement);
		    };
		    PerfectScrollbarComponent.prototype.scrollTo = function (position) {
		        this.elementRef.nativeElement.scrollTop = position;
		        Ps.update(this.elementRef.nativeElement);
		    };
		    __decorate([
		        core_1.Input(), 
		        __metadata('design:type', Object)
		    ], PerfectScrollbarComponent.prototype, "config", void 0);
		    PerfectScrollbarComponent = __decorate([
		        core_1.Component({
		            selector: 'perfect-scrollbar',
		            template: '<ng-content></ng-content>',
		            styles: [__webpack_require__(25)],
		            encapsulation: core_1.ViewEncapsulation.None
		        }),
		        __param(1, core_1.Optional()), 
		        __metadata('design:paramtypes', [core_1.ElementRef, perfect_scrollbar_config_1.PerfectScrollbarConfig])
		    ], PerfectScrollbarComponent);
		    return PerfectScrollbarComponent;
		}());
		exports.PerfectScrollbarComponent = PerfectScrollbarComponent;
		

	/***/ },
	/* 2 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		module.exports = __webpack_require__(3);


	/***/ },
	/* 3 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var destroy = __webpack_require__(4);
		var initialize = __webpack_require__(12);
		var update = __webpack_require__(22);

		module.exports = {
		  initialize: initialize,
		  update: update,
		  destroy: destroy
		};


	/***/ },
	/* 4 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var dom = __webpack_require__(7);
		var instances = __webpack_require__(8);

		module.exports = function (element) {
		  var i = instances.get(element);

		  if (!i) {
		    return;
		  }

		  i.event.unbindAll();
		  dom.remove(i.scrollbarX);
		  dom.remove(i.scrollbarY);
		  dom.remove(i.scrollbarXRail);
		  dom.remove(i.scrollbarYRail);
		  _.removePsClasses(element);

		  instances.remove(element);
		};


	/***/ },
	/* 5 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var cls = __webpack_require__(6);
		var dom = __webpack_require__(7);

		var toInt = exports.toInt = function (x) {
		  return parseInt(x, 10) || 0;
		};

		var clone = exports.clone = function (obj) {
		  if (obj === null) {
		    return null;
		  } else if (obj.constructor === Array) {
		    return obj.map(clone);
		  } else if (typeof obj === 'object') {
		    var result = {};
		    for (var key in obj) {
		      result[key] = clone(obj[key]);
		    }
		    return result;
		  } else {
		    return obj;
		  }
		};

		exports.extend = function (original, source) {
		  var result = clone(original);
		  for (var key in source) {
		    result[key] = clone(source[key]);
		  }
		  return result;
		};

		exports.isEditable = function (el) {
		  return dom.matches(el, "input,[contenteditable]") ||
		         dom.matches(el, "select,[contenteditable]") ||
		         dom.matches(el, "textarea,[contenteditable]") ||
		         dom.matches(el, "button,[contenteditable]");
		};

		exports.removePsClasses = function (element) {
		  var clsList = cls.list(element);
		  for (var i = 0; i < clsList.length; i++) {
		    var className = clsList[i];
		    if (className.indexOf('ps-') === 0) {
		      cls.remove(element, className);
		    }
		  }
		};

		exports.outerWidth = function (element) {
		  return toInt(dom.css(element, 'width')) +
		         toInt(dom.css(element, 'paddingLeft')) +
		         toInt(dom.css(element, 'paddingRight')) +
		         toInt(dom.css(element, 'borderLeftWidth')) +
		         toInt(dom.css(element, 'borderRightWidth'));
		};

		exports.startScrolling = function (element, axis) {
		  cls.add(element, 'ps-in-scrolling');
		  if (typeof axis !== 'undefined') {
		    cls.add(element, 'ps-' + axis);
		  } else {
		    cls.add(element, 'ps-x');
		    cls.add(element, 'ps-y');
		  }
		};

		exports.stopScrolling = function (element, axis) {
		  cls.remove(element, 'ps-in-scrolling');
		  if (typeof axis !== 'undefined') {
		    cls.remove(element, 'ps-' + axis);
		  } else {
		    cls.remove(element, 'ps-x');
		    cls.remove(element, 'ps-y');
		  }
		};

		exports.env = {
		  isWebKit: 'WebkitAppearance' in document.documentElement.style,
		  supportsTouch: (('ontouchstart' in window) || window.DocumentTouch && document instanceof window.DocumentTouch),
		  supportsIePointer: window.navigator.msMaxTouchPoints !== null
		};


	/***/ },
	/* 6 */
	/***/ function(module, exports) {

		'use strict';

		function oldAdd(element, className) {
		  var classes = element.className.split(' ');
		  if (classes.indexOf(className) < 0) {
		    classes.push(className);
		  }
		  element.className = classes.join(' ');
		}

		function oldRemove(element, className) {
		  var classes = element.className.split(' ');
		  var idx = classes.indexOf(className);
		  if (idx >= 0) {
		    classes.splice(idx, 1);
		  }
		  element.className = classes.join(' ');
		}

		exports.add = function (element, className) {
		  if (element.classList) {
		    element.classList.add(className);
		  } else {
		    oldAdd(element, className);
		  }
		};

		exports.remove = function (element, className) {
		  if (element.classList) {
		    element.classList.remove(className);
		  } else {
		    oldRemove(element, className);
		  }
		};

		exports.list = function (element) {
		  if (element.classList) {
		    return Array.prototype.slice.apply(element.classList);
		  } else {
		    return element.className.split(' ');
		  }
		};


	/***/ },
	/* 7 */
	/***/ function(module, exports) {

		'use strict';

		var DOM = {};

		DOM.e = function (tagName, className) {
		  var element = document.createElement(tagName);
		  element.className = className;
		  return element;
		};

		DOM.appendTo = function (child, parent) {
		  parent.appendChild(child);
		  return child;
		};

		function cssGet(element, styleName) {
		  return window.getComputedStyle(element)[styleName];
		}

		function cssSet(element, styleName, styleValue) {
		  if (typeof styleValue === 'number') {
		    styleValue = styleValue.toString() + 'px';
		  }
		  element.style[styleName] = styleValue;
		  return element;
		}

		function cssMultiSet(element, obj) {
		  for (var key in obj) {
		    var val = obj[key];
		    if (typeof val === 'number') {
		      val = val.toString() + 'px';
		    }
		    element.style[key] = val;
		  }
		  return element;
		}

		DOM.css = function (element, styleNameOrObject, styleValue) {
		  if (typeof styleNameOrObject === 'object') {
		    // multiple set with object
		    return cssMultiSet(element, styleNameOrObject);
		  } else {
		    if (typeof styleValue === 'undefined') {
		      return cssGet(element, styleNameOrObject);
		    } else {
		      return cssSet(element, styleNameOrObject, styleValue);
		    }
		  }
		};

		DOM.matches = function (element, query) {
		  if (typeof element.matches !== 'undefined') {
		    return element.matches(query);
		  } else {
		    if (typeof element.matchesSelector !== 'undefined') {
		      return element.matchesSelector(query);
		    } else if (typeof element.webkitMatchesSelector !== 'undefined') {
		      return element.webkitMatchesSelector(query);
		    } else if (typeof element.mozMatchesSelector !== 'undefined') {
		      return element.mozMatchesSelector(query);
		    } else if (typeof element.msMatchesSelector !== 'undefined') {
		      return element.msMatchesSelector(query);
		    }
		  }
		};

		DOM.remove = function (element) {
		  if (typeof element.remove !== 'undefined') {
		    element.remove();
		  } else {
		    if (element.parentNode) {
		      element.parentNode.removeChild(element);
		    }
		  }
		};

		DOM.queryChildren = function (element, selector) {
		  return Array.prototype.filter.call(element.childNodes, function (child) {
		    return DOM.matches(child, selector);
		  });
		};

		module.exports = DOM;


	/***/ },
	/* 8 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var cls = __webpack_require__(6);
		var defaultSettings = __webpack_require__(9);
		var dom = __webpack_require__(7);
		var EventManager = __webpack_require__(10);
		var guid = __webpack_require__(11);

		var instances = {};

		function Instance(element) {
		  var i = this;

		  i.settings = _.clone(defaultSettings);
		  i.containerWidth = null;
		  i.containerHeight = null;
		  i.contentWidth = null;
		  i.contentHeight = null;

		  i.isRtl = dom.css(element, 'direction') === "rtl";
		  i.isNegativeScroll = (function () {
		    var originalScrollLeft = element.scrollLeft;
		    var result = null;
		    element.scrollLeft = -1;
		    result = element.scrollLeft < 0;
		    element.scrollLeft = originalScrollLeft;
		    return result;
		  })();
		  i.negativeScrollAdjustment = i.isNegativeScroll ? element.scrollWidth - element.clientWidth : 0;
		  i.event = new EventManager();
		  i.ownerDocument = element.ownerDocument || document;

		  function focus() {
		    cls.add(element, 'ps-focus');
		  }

		  function blur() {
		    cls.remove(element, 'ps-focus');
		  }

		  i.scrollbarXRail = dom.appendTo(dom.e('div', 'ps-scrollbar-x-rail'), element);
		  i.scrollbarX = dom.appendTo(dom.e('div', 'ps-scrollbar-x'), i.scrollbarXRail);
		  i.scrollbarX.setAttribute('tabindex', 0);
		  i.event.bind(i.scrollbarX, 'focus', focus);
		  i.event.bind(i.scrollbarX, 'blur', blur);
		  i.scrollbarXActive = null;
		  i.scrollbarXWidth = null;
		  i.scrollbarXLeft = null;
		  i.scrollbarXBottom = _.toInt(dom.css(i.scrollbarXRail, 'bottom'));
		  i.isScrollbarXUsingBottom = i.scrollbarXBottom === i.scrollbarXBottom; // !isNaN
		  i.scrollbarXTop = i.isScrollbarXUsingBottom ? null : _.toInt(dom.css(i.scrollbarXRail, 'top'));
		  i.railBorderXWidth = _.toInt(dom.css(i.scrollbarXRail, 'borderLeftWidth')) + _.toInt(dom.css(i.scrollbarXRail, 'borderRightWidth'));
		  // Set rail to display:block to calculate margins
		  dom.css(i.scrollbarXRail, 'display', 'block');
		  i.railXMarginWidth = _.toInt(dom.css(i.scrollbarXRail, 'marginLeft')) + _.toInt(dom.css(i.scrollbarXRail, 'marginRight'));
		  dom.css(i.scrollbarXRail, 'display', '');
		  i.railXWidth = null;
		  i.railXRatio = null;

		  i.scrollbarYRail = dom.appendTo(dom.e('div', 'ps-scrollbar-y-rail'), element);
		  i.scrollbarY = dom.appendTo(dom.e('div', 'ps-scrollbar-y'), i.scrollbarYRail);
		  i.scrollbarY.setAttribute('tabindex', 0);
		  i.event.bind(i.scrollbarY, 'focus', focus);
		  i.event.bind(i.scrollbarY, 'blur', blur);
		  i.scrollbarYActive = null;
		  i.scrollbarYHeight = null;
		  i.scrollbarYTop = null;
		  i.scrollbarYRight = _.toInt(dom.css(i.scrollbarYRail, 'right'));
		  i.isScrollbarYUsingRight = i.scrollbarYRight === i.scrollbarYRight; // !isNaN
		  i.scrollbarYLeft = i.isScrollbarYUsingRight ? null : _.toInt(dom.css(i.scrollbarYRail, 'left'));
		  i.scrollbarYOuterWidth = i.isRtl ? _.outerWidth(i.scrollbarY) : null;
		  i.railBorderYWidth = _.toInt(dom.css(i.scrollbarYRail, 'borderTopWidth')) + _.toInt(dom.css(i.scrollbarYRail, 'borderBottomWidth'));
		  dom.css(i.scrollbarYRail, 'display', 'block');
		  i.railYMarginHeight = _.toInt(dom.css(i.scrollbarYRail, 'marginTop')) + _.toInt(dom.css(i.scrollbarYRail, 'marginBottom'));
		  dom.css(i.scrollbarYRail, 'display', '');
		  i.railYHeight = null;
		  i.railYRatio = null;
		}

		function getId(element) {
		  return element.getAttribute('data-ps-id');
		}

		function setId(element, id) {
		  element.setAttribute('data-ps-id', id);
		}

		function removeId(element) {
		  element.removeAttribute('data-ps-id');
		}

		exports.add = function (element) {
		  var newId = guid();
		  setId(element, newId);
		  instances[newId] = new Instance(element);
		  return instances[newId];
		};

		exports.remove = function (element) {
		  delete instances[getId(element)];
		  removeId(element);
		};

		exports.get = function (element) {
		  return instances[getId(element)];
		};


	/***/ },
	/* 9 */
	/***/ function(module, exports) {

		'use strict';

		module.exports = {
		  handlers: ['click-rail', 'drag-scrollbar', 'keyboard', 'wheel', 'touch'],
		  maxScrollbarLength: null,
		  minScrollbarLength: null,
		  scrollXMarginOffset: 0,
		  scrollYMarginOffset: 0,
		  stopPropagationOnClick: true,
		  suppressScrollX: false,
		  suppressScrollY: false,
		  swipePropagation: true,
		  useBothWheelAxes: false,
		  wheelPropagation: false,
		  wheelSpeed: 1,
		  theme: 'default'
		};


	/***/ },
	/* 10 */
	/***/ function(module, exports) {

		'use strict';

		var EventElement = function (element) {
		  this.element = element;
		  this.events = {};
		};

		EventElement.prototype.bind = function (eventName, handler) {
		  if (typeof this.events[eventName] === 'undefined') {
		    this.events[eventName] = [];
		  }
		  this.events[eventName].push(handler);
		  this.element.addEventListener(eventName, handler, false);
		};

		EventElement.prototype.unbind = function (eventName, handler) {
		  var isHandlerProvided = (typeof handler !== 'undefined');
		  this.events[eventName] = this.events[eventName].filter(function (hdlr) {
		    if (isHandlerProvided && hdlr !== handler) {
		      return true;
		    }
		    this.element.removeEventListener(eventName, hdlr, false);
		    return false;
		  }, this);
		};

		EventElement.prototype.unbindAll = function () {
		  for (var name in this.events) {
		    this.unbind(name);
		  }
		};

		var EventManager = function () {
		  this.eventElements = [];
		};

		EventManager.prototype.eventElement = function (element) {
		  var ee = this.eventElements.filter(function (eventElement) {
		    return eventElement.element === element;
		  })[0];
		  if (typeof ee === 'undefined') {
		    ee = new EventElement(element);
		    this.eventElements.push(ee);
		  }
		  return ee;
		};

		EventManager.prototype.bind = function (element, eventName, handler) {
		  this.eventElement(element).bind(eventName, handler);
		};

		EventManager.prototype.unbind = function (element, eventName, handler) {
		  this.eventElement(element).unbind(eventName, handler);
		};

		EventManager.prototype.unbindAll = function () {
		  for (var i = 0; i < this.eventElements.length; i++) {
		    this.eventElements[i].unbindAll();
		  }
		};

		EventManager.prototype.once = function (element, eventName, handler) {
		  var ee = this.eventElement(element);
		  var onceHandler = function (e) {
		    ee.unbind(eventName, onceHandler);
		    handler(e);
		  };
		  ee.bind(eventName, onceHandler);
		};

		module.exports = EventManager;


	/***/ },
	/* 11 */
	/***/ function(module, exports) {

		'use strict';

		module.exports = (function () {
		  function s4() {
		    return Math.floor((1 + Math.random()) * 0x10000)
		               .toString(16)
		               .substring(1);
		  }
		  return function () {
		    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
		           s4() + '-' + s4() + s4() + s4();
		  };
		})();


	/***/ },
	/* 12 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var cls = __webpack_require__(6);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);

		// Handlers
		var handlers = {
		  'click-rail': __webpack_require__(15),
		  'drag-scrollbar': __webpack_require__(16),
		  'keyboard': __webpack_require__(17),
		  'wheel': __webpack_require__(18),
		  'touch': __webpack_require__(19),
		  'selection': __webpack_require__(20)
		};
		var nativeScrollHandler = __webpack_require__(21);

		module.exports = function (element, userSettings) {
		  userSettings = typeof userSettings === 'object' ? userSettings : {};

		  cls.add(element, 'ps-container');

		  // Create a plugin instance.
		  var i = instances.add(element);

		  i.settings = _.extend(i.settings, userSettings);
		  cls.add(element, 'ps-theme-' + i.settings.theme);

		  i.settings.handlers.forEach(function (handlerName) {
		    handlers[handlerName](element);
		  });

		  nativeScrollHandler(element);

		  updateGeometry(element);
		};


	/***/ },
	/* 13 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var cls = __webpack_require__(6);
		var dom = __webpack_require__(7);
		var instances = __webpack_require__(8);
		var updateScroll = __webpack_require__(14);

		function getThumbSize(i, thumbSize) {
		  if (i.settings.minScrollbarLength) {
		    thumbSize = Math.max(thumbSize, i.settings.minScrollbarLength);
		  }
		  if (i.settings.maxScrollbarLength) {
		    thumbSize = Math.min(thumbSize, i.settings.maxScrollbarLength);
		  }
		  return thumbSize;
		}

		function updateCss(element, i) {
		  var xRailOffset = {width: i.railXWidth};
		  if (i.isRtl) {
		    xRailOffset.left = i.negativeScrollAdjustment + element.scrollLeft + i.containerWidth - i.contentWidth;
		  } else {
		    xRailOffset.left = element.scrollLeft;
		  }
		  if (i.isScrollbarXUsingBottom) {
		    xRailOffset.bottom = i.scrollbarXBottom - element.scrollTop;
		  } else {
		    xRailOffset.top = i.scrollbarXTop + element.scrollTop;
		  }
		  dom.css(i.scrollbarXRail, xRailOffset);

		  var yRailOffset = {top: element.scrollTop, height: i.railYHeight};
		  if (i.isScrollbarYUsingRight) {
		    if (i.isRtl) {
		      yRailOffset.right = i.contentWidth - (i.negativeScrollAdjustment + element.scrollLeft) - i.scrollbarYRight - i.scrollbarYOuterWidth;
		    } else {
		      yRailOffset.right = i.scrollbarYRight - element.scrollLeft;
		    }
		  } else {
		    if (i.isRtl) {
		      yRailOffset.left = i.negativeScrollAdjustment + element.scrollLeft + i.containerWidth * 2 - i.contentWidth - i.scrollbarYLeft - i.scrollbarYOuterWidth;
		    } else {
		      yRailOffset.left = i.scrollbarYLeft + element.scrollLeft;
		    }
		  }
		  dom.css(i.scrollbarYRail, yRailOffset);

		  dom.css(i.scrollbarX, {left: i.scrollbarXLeft, width: i.scrollbarXWidth - i.railBorderXWidth});
		  dom.css(i.scrollbarY, {top: i.scrollbarYTop, height: i.scrollbarYHeight - i.railBorderYWidth});
		}

		module.exports = function (element) {
		  var i = instances.get(element);

		  i.containerWidth = element.clientWidth;
		  i.containerHeight = element.clientHeight;
		  i.contentWidth = element.scrollWidth;
		  i.contentHeight = element.scrollHeight;

		  var existingRails;
		  if (!element.contains(i.scrollbarXRail)) {
		    existingRails = dom.queryChildren(element, '.ps-scrollbar-x-rail');
		    if (existingRails.length > 0) {
		      existingRails.forEach(function (rail) {
		        dom.remove(rail);
		      });
		    }
		    dom.appendTo(i.scrollbarXRail, element);
		  }
		  if (!element.contains(i.scrollbarYRail)) {
		    existingRails = dom.queryChildren(element, '.ps-scrollbar-y-rail');
		    if (existingRails.length > 0) {
		      existingRails.forEach(function (rail) {
		        dom.remove(rail);
		      });
		    }
		    dom.appendTo(i.scrollbarYRail, element);
		  }

		  if (!i.settings.suppressScrollX && i.containerWidth + i.settings.scrollXMarginOffset < i.contentWidth) {
		    i.scrollbarXActive = true;
		    i.railXWidth = i.containerWidth - i.railXMarginWidth;
		    i.railXRatio = i.containerWidth / i.railXWidth;
		    i.scrollbarXWidth = getThumbSize(i, _.toInt(i.railXWidth * i.containerWidth / i.contentWidth));
		    i.scrollbarXLeft = _.toInt((i.negativeScrollAdjustment + element.scrollLeft) * (i.railXWidth - i.scrollbarXWidth) / (i.contentWidth - i.containerWidth));
		  } else {
		    i.scrollbarXActive = false;
		  }

		  if (!i.settings.suppressScrollY && i.containerHeight + i.settings.scrollYMarginOffset < i.contentHeight) {
		    i.scrollbarYActive = true;
		    i.railYHeight = i.containerHeight - i.railYMarginHeight;
		    i.railYRatio = i.containerHeight / i.railYHeight;
		    i.scrollbarYHeight = getThumbSize(i, _.toInt(i.railYHeight * i.containerHeight / i.contentHeight));
		    i.scrollbarYTop = _.toInt(element.scrollTop * (i.railYHeight - i.scrollbarYHeight) / (i.contentHeight - i.containerHeight));
		  } else {
		    i.scrollbarYActive = false;
		  }

		  if (i.scrollbarXLeft >= i.railXWidth - i.scrollbarXWidth) {
		    i.scrollbarXLeft = i.railXWidth - i.scrollbarXWidth;
		  }
		  if (i.scrollbarYTop >= i.railYHeight - i.scrollbarYHeight) {
		    i.scrollbarYTop = i.railYHeight - i.scrollbarYHeight;
		  }

		  updateCss(element, i);

		  if (i.scrollbarXActive) {
		    cls.add(element, 'ps-active-x');
		  } else {
		    cls.remove(element, 'ps-active-x');
		    i.scrollbarXWidth = 0;
		    i.scrollbarXLeft = 0;
		    updateScroll(element, 'left', 0);
		  }
		  if (i.scrollbarYActive) {
		    cls.add(element, 'ps-active-y');
		  } else {
		    cls.remove(element, 'ps-active-y');
		    i.scrollbarYHeight = 0;
		    i.scrollbarYTop = 0;
		    updateScroll(element, 'top', 0);
		  }
		};


	/***/ },
	/* 14 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var instances = __webpack_require__(8);

		var upEvent = document.createEvent('Event');
		var downEvent = document.createEvent('Event');
		var leftEvent = document.createEvent('Event');
		var rightEvent = document.createEvent('Event');
		var yEvent = document.createEvent('Event');
		var xEvent = document.createEvent('Event');
		var xStartEvent = document.createEvent('Event');
		var xEndEvent = document.createEvent('Event');
		var yStartEvent = document.createEvent('Event');
		var yEndEvent = document.createEvent('Event');
		var lastTop;
		var lastLeft;

		upEvent.initEvent('ps-scroll-up', true, true);
		downEvent.initEvent('ps-scroll-down', true, true);
		leftEvent.initEvent('ps-scroll-left', true, true);
		rightEvent.initEvent('ps-scroll-right', true, true);
		yEvent.initEvent('ps-scroll-y', true, true);
		xEvent.initEvent('ps-scroll-x', true, true);
		xStartEvent.initEvent('ps-x-reach-start', true, true);
		xEndEvent.initEvent('ps-x-reach-end', true, true);
		yStartEvent.initEvent('ps-y-reach-start', true, true);
		yEndEvent.initEvent('ps-y-reach-end', true, true);

		module.exports = function (element, axis, value) {
		  if (typeof element === 'undefined') {
		    throw 'You must provide an element to the update-scroll function';
		  }

		  if (typeof axis === 'undefined') {
		    throw 'You must provide an axis to the update-scroll function';
		  }

		  if (typeof value === 'undefined') {
		    throw 'You must provide a value to the update-scroll function';
		  }

		  if (axis === 'top' && value <= 0) {
		    element.scrollTop = value = 0; // don't allow negative scroll
		    element.dispatchEvent(yStartEvent);
		  }

		  if (axis === 'left' && value <= 0) {
		    element.scrollLeft = value = 0; // don't allow negative scroll
		    element.dispatchEvent(xStartEvent);
		  }

		  var i = instances.get(element);

		  if (axis === 'top' && value >= i.contentHeight - i.containerHeight) {
		    // don't allow scroll past container
		    value = i.contentHeight - i.containerHeight;
		    if (value - element.scrollTop <= 1) {
		      // mitigates rounding errors on non-subpixel scroll values
		      value = element.scrollTop;
		    } else {
		      element.scrollTop = value;
		    }
		    element.dispatchEvent(yEndEvent);
		  }

		  if (axis === 'left' && value >= i.contentWidth - i.containerWidth) {
		    // don't allow scroll past container
		    value = i.contentWidth - i.containerWidth;
		    if (value - element.scrollLeft <= 1) {
		      // mitigates rounding errors on non-subpixel scroll values
		      value = element.scrollLeft;
		    } else {
		      element.scrollLeft = value;
		    }
		    element.dispatchEvent(xEndEvent);
		  }

		  if (!lastTop) {
		    lastTop = element.scrollTop;
		  }

		  if (!lastLeft) {
		    lastLeft = element.scrollLeft;
		  }

		  if (axis === 'top' && value < lastTop) {
		    element.dispatchEvent(upEvent);
		  }

		  if (axis === 'top' && value > lastTop) {
		    element.dispatchEvent(downEvent);
		  }

		  if (axis === 'left' && value < lastLeft) {
		    element.dispatchEvent(leftEvent);
		  }

		  if (axis === 'left' && value > lastLeft) {
		    element.dispatchEvent(rightEvent);
		  }

		  if (axis === 'top') {
		    element.scrollTop = lastTop = value;
		    element.dispatchEvent(yEvent);
		  }

		  if (axis === 'left') {
		    element.scrollLeft = lastLeft = value;
		    element.dispatchEvent(xEvent);
		  }

		};


	/***/ },
	/* 15 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindClickRailHandler(element, i) {
		  function pageOffset(el) {
		    return el.getBoundingClientRect();
		  }
		  var stopPropagation = function (e) { e.stopPropagation(); };

		  if (i.settings.stopPropagationOnClick) {
		    i.event.bind(i.scrollbarY, 'click', stopPropagation);
		  }
		  i.event.bind(i.scrollbarYRail, 'click', function (e) {
		    var halfOfScrollbarLength = _.toInt(i.scrollbarYHeight / 2);
		    var positionTop = i.railYRatio * (e.pageY - window.pageYOffset - pageOffset(i.scrollbarYRail).top - halfOfScrollbarLength);
		    var maxPositionTop = i.railYRatio * (i.railYHeight - i.scrollbarYHeight);
		    var positionRatio = positionTop / maxPositionTop;

		    if (positionRatio < 0) {
		      positionRatio = 0;
		    } else if (positionRatio > 1) {
		      positionRatio = 1;
		    }

		    updateScroll(element, 'top', (i.contentHeight - i.containerHeight) * positionRatio);
		    updateGeometry(element);

		    e.stopPropagation();
		  });

		  if (i.settings.stopPropagationOnClick) {
		    i.event.bind(i.scrollbarX, 'click', stopPropagation);
		  }
		  i.event.bind(i.scrollbarXRail, 'click', function (e) {
		    var halfOfScrollbarLength = _.toInt(i.scrollbarXWidth / 2);
		    var positionLeft = i.railXRatio * (e.pageX - window.pageXOffset - pageOffset(i.scrollbarXRail).left - halfOfScrollbarLength);
		    var maxPositionLeft = i.railXRatio * (i.railXWidth - i.scrollbarXWidth);
		    var positionRatio = positionLeft / maxPositionLeft;

		    if (positionRatio < 0) {
		      positionRatio = 0;
		    } else if (positionRatio > 1) {
		      positionRatio = 1;
		    }

		    updateScroll(element, 'left', ((i.contentWidth - i.containerWidth) * positionRatio) - i.negativeScrollAdjustment);
		    updateGeometry(element);

		    e.stopPropagation();
		  });
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindClickRailHandler(element, i);
		};


	/***/ },
	/* 16 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var dom = __webpack_require__(7);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindMouseScrollXHandler(element, i) {
		  var currentLeft = null;
		  var currentPageX = null;

		  function updateScrollLeft(deltaX) {
		    var newLeft = currentLeft + (deltaX * i.railXRatio);
		    var maxLeft = Math.max(0, i.scrollbarXRail.getBoundingClientRect().left) + (i.railXRatio * (i.railXWidth - i.scrollbarXWidth));

		    if (newLeft < 0) {
		      i.scrollbarXLeft = 0;
		    } else if (newLeft > maxLeft) {
		      i.scrollbarXLeft = maxLeft;
		    } else {
		      i.scrollbarXLeft = newLeft;
		    }

		    var scrollLeft = _.toInt(i.scrollbarXLeft * (i.contentWidth - i.containerWidth) / (i.containerWidth - (i.railXRatio * i.scrollbarXWidth))) - i.negativeScrollAdjustment;
		    updateScroll(element, 'left', scrollLeft);
		  }

		  var mouseMoveHandler = function (e) {
		    updateScrollLeft(e.pageX - currentPageX);
		    updateGeometry(element);
		    e.stopPropagation();
		    e.preventDefault();
		  };

		  var mouseUpHandler = function () {
		    _.stopScrolling(element, 'x');
		    i.event.unbind(i.ownerDocument, 'mousemove', mouseMoveHandler);
		  };

		  i.event.bind(i.scrollbarX, 'mousedown', function (e) {
		    currentPageX = e.pageX;
		    currentLeft = _.toInt(dom.css(i.scrollbarX, 'left')) * i.railXRatio;
		    _.startScrolling(element, 'x');

		    i.event.bind(i.ownerDocument, 'mousemove', mouseMoveHandler);
		    i.event.once(i.ownerDocument, 'mouseup', mouseUpHandler);

		    e.stopPropagation();
		    e.preventDefault();
		  });
		}

		function bindMouseScrollYHandler(element, i) {
		  var currentTop = null;
		  var currentPageY = null;

		  function updateScrollTop(deltaY) {
		    var newTop = currentTop + (deltaY * i.railYRatio);
		    var maxTop = Math.max(0, i.scrollbarYRail.getBoundingClientRect().top) + (i.railYRatio * (i.railYHeight - i.scrollbarYHeight));

		    if (newTop < 0) {
		      i.scrollbarYTop = 0;
		    } else if (newTop > maxTop) {
		      i.scrollbarYTop = maxTop;
		    } else {
		      i.scrollbarYTop = newTop;
		    }

		    var scrollTop = _.toInt(i.scrollbarYTop * (i.contentHeight - i.containerHeight) / (i.containerHeight - (i.railYRatio * i.scrollbarYHeight)));
		    updateScroll(element, 'top', scrollTop);
		  }

		  var mouseMoveHandler = function (e) {
		    updateScrollTop(e.pageY - currentPageY);
		    updateGeometry(element);
		    e.stopPropagation();
		    e.preventDefault();
		  };

		  var mouseUpHandler = function () {
		    _.stopScrolling(element, 'y');
		    i.event.unbind(i.ownerDocument, 'mousemove', mouseMoveHandler);
		  };

		  i.event.bind(i.scrollbarY, 'mousedown', function (e) {
		    currentPageY = e.pageY;
		    currentTop = _.toInt(dom.css(i.scrollbarY, 'top')) * i.railYRatio;
		    _.startScrolling(element, 'y');

		    i.event.bind(i.ownerDocument, 'mousemove', mouseMoveHandler);
		    i.event.once(i.ownerDocument, 'mouseup', mouseUpHandler);

		    e.stopPropagation();
		    e.preventDefault();
		  });
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindMouseScrollXHandler(element, i);
		  bindMouseScrollYHandler(element, i);
		};


	/***/ },
	/* 17 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var dom = __webpack_require__(7);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindKeyboardHandler(element, i) {
		  var hovered = false;
		  i.event.bind(element, 'mouseenter', function () {
		    hovered = true;
		  });
		  i.event.bind(element, 'mouseleave', function () {
		    hovered = false;
		  });

		  var shouldPrevent = false;
		  function shouldPreventDefault(deltaX, deltaY) {
		    var scrollTop = element.scrollTop;
		    if (deltaX === 0) {
		      if (!i.scrollbarYActive) {
		        return false;
		      }
		      if ((scrollTop === 0 && deltaY > 0) || (scrollTop >= i.contentHeight - i.containerHeight && deltaY < 0)) {
		        return !i.settings.wheelPropagation;
		      }
		    }

		    var scrollLeft = element.scrollLeft;
		    if (deltaY === 0) {
		      if (!i.scrollbarXActive) {
		        return false;
		      }
		      if ((scrollLeft === 0 && deltaX < 0) || (scrollLeft >= i.contentWidth - i.containerWidth && deltaX > 0)) {
		        return !i.settings.wheelPropagation;
		      }
		    }
		    return true;
		  }

		  i.event.bind(i.ownerDocument, 'keydown', function (e) {
		    if ((e.isDefaultPrevented && e.isDefaultPrevented()) || e.defaultPrevented) {
		      return;
		    }

		    var focused = dom.matches(i.scrollbarX, ':focus') ||
		                  dom.matches(i.scrollbarY, ':focus');

		    if (!hovered && !focused) {
		      return;
		    }

		    var activeElement = document.activeElement ? document.activeElement : i.ownerDocument.activeElement;
		    if (activeElement) {
		      if (activeElement.tagName === 'IFRAME') {
		        activeElement = activeElement.contentDocument.activeElement;
		      } else {
		        // go deeper if element is a webcomponent
		        while (activeElement.shadowRoot) {
		          activeElement = activeElement.shadowRoot.activeElement;
		        }
		      }
		      if (_.isEditable(activeElement)) {
		        return;
		      }
		    }

		    var deltaX = 0;
		    var deltaY = 0;

		    switch (e.which) {
		    case 37: // left
		      deltaX = -30;
		      break;
		    case 38: // up
		      deltaY = 30;
		      break;
		    case 39: // right
		      deltaX = 30;
		      break;
		    case 40: // down
		      deltaY = -30;
		      break;
		    case 33: // page up
		      deltaY = 90;
		      break;
		    case 32: // space bar
		      if (e.shiftKey) {
		        deltaY = 90;
		      } else {
		        deltaY = -90;
		      }
		      break;
		    case 34: // page down
		      deltaY = -90;
		      break;
		    case 35: // end
		      if (e.ctrlKey) {
		        deltaY = -i.contentHeight;
		      } else {
		        deltaY = -i.containerHeight;
		      }
		      break;
		    case 36: // home
		      if (e.ctrlKey) {
		        deltaY = element.scrollTop;
		      } else {
		        deltaY = i.containerHeight;
		      }
		      break;
		    default:
		      return;
		    }

		    updateScroll(element, 'top', element.scrollTop - deltaY);
		    updateScroll(element, 'left', element.scrollLeft + deltaX);
		    updateGeometry(element);

		    shouldPrevent = shouldPreventDefault(deltaX, deltaY);
		    if (shouldPrevent) {
		      e.preventDefault();
		    }
		  });
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindKeyboardHandler(element, i);
		};


	/***/ },
	/* 18 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindMouseWheelHandler(element, i) {
		  var shouldPrevent = false;

		  function shouldPreventDefault(deltaX, deltaY) {
		    var scrollTop = element.scrollTop;
		    if (deltaX === 0) {
		      if (!i.scrollbarYActive) {
		        return false;
		      }
		      if ((scrollTop === 0 && deltaY > 0) || (scrollTop >= i.contentHeight - i.containerHeight && deltaY < 0)) {
		        return !i.settings.wheelPropagation;
		      }
		    }

		    var scrollLeft = element.scrollLeft;
		    if (deltaY === 0) {
		      if (!i.scrollbarXActive) {
		        return false;
		      }
		      if ((scrollLeft === 0 && deltaX < 0) || (scrollLeft >= i.contentWidth - i.containerWidth && deltaX > 0)) {
		        return !i.settings.wheelPropagation;
		      }
		    }
		    return true;
		  }

		  function getDeltaFromEvent(e) {
		    var deltaX = e.deltaX;
		    var deltaY = -1 * e.deltaY;

		    if (typeof deltaX === "undefined" || typeof deltaY === "undefined") {
		      // OS X Safari
		      deltaX = -1 * e.wheelDeltaX / 6;
		      deltaY = e.wheelDeltaY / 6;
		    }

		    if (e.deltaMode && e.deltaMode === 1) {
		      // Firefox in deltaMode 1: Line scrolling
		      deltaX *= 10;
		      deltaY *= 10;
		    }

		    if (deltaX !== deltaX && deltaY !== deltaY/* NaN checks */) {
		      // IE in some mouse drivers
		      deltaX = 0;
		      deltaY = e.wheelDelta;
		    }

		    return [deltaX, deltaY];
		  }

		  function shouldBeConsumedByChild(deltaX, deltaY) {
		    var child = element.querySelector('textarea:hover, select[multiple]:hover, .ps-child:hover');
		    if (child) {
		      if (child.tagName !== 'TEXTAREA' && !window.getComputedStyle(child).overflow.match(/(scroll|auto)/)) {
		        return false;
		      }

		      var maxScrollTop = child.scrollHeight - child.clientHeight;
		      if (maxScrollTop > 0) {
		        if (!(child.scrollTop === 0 && deltaY > 0) && !(child.scrollTop === maxScrollTop && deltaY < 0)) {
		          return true;
		        }
		      }
		      var maxScrollLeft = child.scrollLeft - child.clientWidth;
		      if (maxScrollLeft > 0) {
		        if (!(child.scrollLeft === 0 && deltaX < 0) && !(child.scrollLeft === maxScrollLeft && deltaX > 0)) {
		          return true;
		        }
		      }
		    }
		    return false;
		  }

		  function mousewheelHandler(e) {
		    var delta = getDeltaFromEvent(e);

		    var deltaX = delta[0];
		    var deltaY = delta[1];

		    if (shouldBeConsumedByChild(deltaX, deltaY)) {
		      return;
		    }

		    shouldPrevent = false;
		    if (!i.settings.useBothWheelAxes) {
		      // deltaX will only be used for horizontal scrolling and deltaY will
		      // only be used for vertical scrolling - this is the default
		      updateScroll(element, 'top', element.scrollTop - (deltaY * i.settings.wheelSpeed));
		      updateScroll(element, 'left', element.scrollLeft + (deltaX * i.settings.wheelSpeed));
		    } else if (i.scrollbarYActive && !i.scrollbarXActive) {
		      // only vertical scrollbar is active and useBothWheelAxes option is
		      // active, so let's scroll vertical bar using both mouse wheel axes
		      if (deltaY) {
		        updateScroll(element, 'top', element.scrollTop - (deltaY * i.settings.wheelSpeed));
		      } else {
		        updateScroll(element, 'top', element.scrollTop + (deltaX * i.settings.wheelSpeed));
		      }
		      shouldPrevent = true;
		    } else if (i.scrollbarXActive && !i.scrollbarYActive) {
		      // useBothWheelAxes and only horizontal bar is active, so use both
		      // wheel axes for horizontal bar
		      if (deltaX) {
		        updateScroll(element, 'left', element.scrollLeft + (deltaX * i.settings.wheelSpeed));
		      } else {
		        updateScroll(element, 'left', element.scrollLeft - (deltaY * i.settings.wheelSpeed));
		      }
		      shouldPrevent = true;
		    }

		    updateGeometry(element);

		    shouldPrevent = (shouldPrevent || shouldPreventDefault(deltaX, deltaY));
		    if (shouldPrevent) {
		      e.stopPropagation();
		      e.preventDefault();
		    }
		  }

		  if (typeof window.onwheel !== "undefined") {
		    i.event.bind(element, 'wheel', mousewheelHandler);
		  } else if (typeof window.onmousewheel !== "undefined") {
		    i.event.bind(element, 'mousewheel', mousewheelHandler);
		  }
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindMouseWheelHandler(element, i);
		};


	/***/ },
	/* 19 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindTouchHandler(element, i, supportsTouch, supportsIePointer) {
		  function shouldPreventDefault(deltaX, deltaY) {
		    var scrollTop = element.scrollTop;
		    var scrollLeft = element.scrollLeft;
		    var magnitudeX = Math.abs(deltaX);
		    var magnitudeY = Math.abs(deltaY);

		    if (magnitudeY > magnitudeX) {
		      // user is perhaps trying to swipe up/down the page

		      if (((deltaY < 0) && (scrollTop === i.contentHeight - i.containerHeight)) ||
		          ((deltaY > 0) && (scrollTop === 0))) {
		        return !i.settings.swipePropagation;
		      }
		    } else if (magnitudeX > magnitudeY) {
		      // user is perhaps trying to swipe left/right across the page

		      if (((deltaX < 0) && (scrollLeft === i.contentWidth - i.containerWidth)) ||
		          ((deltaX > 0) && (scrollLeft === 0))) {
		        return !i.settings.swipePropagation;
		      }
		    }

		    return true;
		  }

		  function applyTouchMove(differenceX, differenceY) {
		    updateScroll(element, 'top', element.scrollTop - differenceY);
		    updateScroll(element, 'left', element.scrollLeft - differenceX);

		    updateGeometry(element);
		  }

		  var startOffset = {};
		  var startTime = 0;
		  var speed = {};
		  var easingLoop = null;
		  var inGlobalTouch = false;
		  var inLocalTouch = false;

		  function globalTouchStart() {
		    inGlobalTouch = true;
		  }
		  function globalTouchEnd() {
		    inGlobalTouch = false;
		  }

		  function getTouch(e) {
		    if (e.targetTouches) {
		      return e.targetTouches[0];
		    } else {
		      // Maybe IE pointer
		      return e;
		    }
		  }
		  function shouldHandle(e) {
		    if (e.targetTouches && e.targetTouches.length === 1) {
		      return true;
		    }
		    if (e.pointerType && e.pointerType !== 'mouse' && e.pointerType !== e.MSPOINTER_TYPE_MOUSE) {
		      return true;
		    }
		    return false;
		  }
		  function touchStart(e) {
		    if (shouldHandle(e)) {
		      inLocalTouch = true;

		      var touch = getTouch(e);

		      startOffset.pageX = touch.pageX;
		      startOffset.pageY = touch.pageY;

		      startTime = (new Date()).getTime();

		      if (easingLoop !== null) {
		        clearInterval(easingLoop);
		      }

		      e.stopPropagation();
		    }
		  }
		  function touchMove(e) {
		    if (!inLocalTouch && i.settings.swipePropagation) {
		      touchStart(e);
		    }
		    if (!inGlobalTouch && inLocalTouch && shouldHandle(e)) {
		      var touch = getTouch(e);

		      var currentOffset = {pageX: touch.pageX, pageY: touch.pageY};

		      var differenceX = currentOffset.pageX - startOffset.pageX;
		      var differenceY = currentOffset.pageY - startOffset.pageY;

		      applyTouchMove(differenceX, differenceY);
		      startOffset = currentOffset;

		      var currentTime = (new Date()).getTime();

		      var timeGap = currentTime - startTime;
		      if (timeGap > 0) {
		        speed.x = differenceX / timeGap;
		        speed.y = differenceY / timeGap;
		        startTime = currentTime;
		      }

		      if (shouldPreventDefault(differenceX, differenceY)) {
		        e.stopPropagation();
		        e.preventDefault();
		      }
		    }
		  }
		  function touchEnd() {
		    if (!inGlobalTouch && inLocalTouch) {
		      inLocalTouch = false;

		      clearInterval(easingLoop);
		      easingLoop = setInterval(function () {
		        if (!instances.get(element)) {
		          clearInterval(easingLoop);
		          return;
		        }

		        if (Math.abs(speed.x) < 0.01 && Math.abs(speed.y) < 0.01) {
		          clearInterval(easingLoop);
		          return;
		        }

		        applyTouchMove(speed.x * 30, speed.y * 30);

		        speed.x *= 0.8;
		        speed.y *= 0.8;
		      }, 10);
		    }
		  }

		  if (supportsTouch) {
		    i.event.bind(window, 'touchstart', globalTouchStart);
		    i.event.bind(window, 'touchend', globalTouchEnd);
		    i.event.bind(element, 'touchstart', touchStart);
		    i.event.bind(element, 'touchmove', touchMove);
		    i.event.bind(element, 'touchend', touchEnd);
		  }

		  if (supportsIePointer) {
		    if (window.PointerEvent) {
		      i.event.bind(window, 'pointerdown', globalTouchStart);
		      i.event.bind(window, 'pointerup', globalTouchEnd);
		      i.event.bind(element, 'pointerdown', touchStart);
		      i.event.bind(element, 'pointermove', touchMove);
		      i.event.bind(element, 'pointerup', touchEnd);
		    } else if (window.MSPointerEvent) {
		      i.event.bind(window, 'MSPointerDown', globalTouchStart);
		      i.event.bind(window, 'MSPointerUp', globalTouchEnd);
		      i.event.bind(element, 'MSPointerDown', touchStart);
		      i.event.bind(element, 'MSPointerMove', touchMove);
		      i.event.bind(element, 'MSPointerUp', touchEnd);
		    }
		  }
		}

		module.exports = function (element) {
		  if (!_.env.supportsTouch && !_.env.supportsIePointer) {
		    return;
		  }

		  var i = instances.get(element);
		  bindTouchHandler(element, i, _.env.supportsTouch, _.env.supportsIePointer);
		};


	/***/ },
	/* 20 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		function bindSelectionHandler(element, i) {
		  function getRangeNode() {
		    var selection = window.getSelection ? window.getSelection() :
		                    document.getSelection ? document.getSelection() : '';
		    if (selection.toString().length === 0) {
		      return null;
		    } else {
		      return selection.getRangeAt(0).commonAncestorContainer;
		    }
		  }

		  var scrollingLoop = null;
		  var scrollDiff = {top: 0, left: 0};
		  function startScrolling() {
		    if (!scrollingLoop) {
		      scrollingLoop = setInterval(function () {
		        if (!instances.get(element)) {
		          clearInterval(scrollingLoop);
		          return;
		        }

		        updateScroll(element, 'top', element.scrollTop + scrollDiff.top);
		        updateScroll(element, 'left', element.scrollLeft + scrollDiff.left);
		        updateGeometry(element);
		      }, 50); // every .1 sec
		    }
		  }
		  function stopScrolling() {
		    if (scrollingLoop) {
		      clearInterval(scrollingLoop);
		      scrollingLoop = null;
		    }
		    _.stopScrolling(element);
		  }

		  var isSelected = false;
		  i.event.bind(i.ownerDocument, 'selectionchange', function () {
		    if (element.contains(getRangeNode())) {
		      isSelected = true;
		    } else {
		      isSelected = false;
		      stopScrolling();
		    }
		  });
		  i.event.bind(window, 'mouseup', function () {
		    if (isSelected) {
		      isSelected = false;
		      stopScrolling();
		    }
		  });

		  i.event.bind(window, 'mousemove', function (e) {
		    if (isSelected) {
		      var mousePosition = {x: e.pageX, y: e.pageY};
		      var containerGeometry = {
		        left: element.offsetLeft,
		        right: element.offsetLeft + element.offsetWidth,
		        top: element.offsetTop,
		        bottom: element.offsetTop + element.offsetHeight
		      };

		      if (mousePosition.x < containerGeometry.left + 3) {
		        scrollDiff.left = -5;
		        _.startScrolling(element, 'x');
		      } else if (mousePosition.x > containerGeometry.right - 3) {
		        scrollDiff.left = 5;
		        _.startScrolling(element, 'x');
		      } else {
		        scrollDiff.left = 0;
		      }

		      if (mousePosition.y < containerGeometry.top + 3) {
		        if (containerGeometry.top + 3 - mousePosition.y < 5) {
		          scrollDiff.top = -5;
		        } else {
		          scrollDiff.top = -20;
		        }
		        _.startScrolling(element, 'y');
		      } else if (mousePosition.y > containerGeometry.bottom - 3) {
		        if (mousePosition.y - containerGeometry.bottom + 3 < 5) {
		          scrollDiff.top = 5;
		        } else {
		          scrollDiff.top = 20;
		        }
		        _.startScrolling(element, 'y');
		      } else {
		        scrollDiff.top = 0;
		      }

		      if (scrollDiff.top === 0 && scrollDiff.left === 0) {
		        stopScrolling();
		      } else {
		        startScrolling();
		      }
		    }
		  });
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindSelectionHandler(element, i);
		};


	/***/ },
	/* 21 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);

		function bindNativeScrollHandler(element, i) {
		  i.event.bind(element, 'scroll', function () {
		    updateGeometry(element);
		  });
		}

		module.exports = function (element) {
		  var i = instances.get(element);
		  bindNativeScrollHandler(element, i);
		};


	/***/ },
	/* 22 */
	/***/ function(module, exports, __webpack_require__) {

		'use strict';

		var _ = __webpack_require__(5);
		var dom = __webpack_require__(7);
		var instances = __webpack_require__(8);
		var updateGeometry = __webpack_require__(13);
		var updateScroll = __webpack_require__(14);

		module.exports = function (element) {
		  var i = instances.get(element);

		  if (!i) {
		    return;
		  }

		  // Recalcuate negative scrollLeft adjustment
		  i.negativeScrollAdjustment = i.isNegativeScroll ? element.scrollWidth - element.clientWidth : 0;

		  // Recalculate rail margins
		  dom.css(i.scrollbarXRail, 'display', 'block');
		  dom.css(i.scrollbarYRail, 'display', 'block');
		  i.railXMarginWidth = _.toInt(dom.css(i.scrollbarXRail, 'marginLeft')) + _.toInt(dom.css(i.scrollbarXRail, 'marginRight'));
		  i.railYMarginHeight = _.toInt(dom.css(i.scrollbarYRail, 'marginTop')) + _.toInt(dom.css(i.scrollbarYRail, 'marginBottom'));

		  // Hide scrollbars not to affect scrollWidth and scrollHeight
		  dom.css(i.scrollbarXRail, 'display', 'none');
		  dom.css(i.scrollbarYRail, 'display', 'none');

		  updateGeometry(element);

		  // Update top/left scroll to trigger events
		  updateScroll(element, 'top', element.scrollTop);
		  updateScroll(element, 'left', element.scrollLeft);

		  dom.css(i.scrollbarXRail, 'display', '');
		  dom.css(i.scrollbarYRail, 'display', '');
		};


	/***/ },
	/* 23 */
	/***/ function(module, exports) {

		module.exports = __WEBPACK_EXTERNAL_MODULE_23__;

	/***/ },
	/* 24 */
	/***/ function(module, exports) {

		"use strict";
		var PerfectScrollbarConfig = (function () {
		    function PerfectScrollbarConfig(config) {
		        if (config === void 0) { config = {}; }
		        this.wheelSpeed = 1;
		        this.wheelPropagation = false;
		        this.swipePropagation = true;
		        this.minScrollbarLength = null;
		        this.maxScrollbarLength = null;
		        this.useBothWheelAxes = false;
		        this.suppressScrollX = false;
		        this.suppressScrollY = false;
		        this.scrollXMarginOffset = 0;
		        this.scrollYMarginOffset = 0;
		        this.stopPropagationOnClick = true;
		        this.assign(config);
		    }
		    PerfectScrollbarConfig.prototype.assign = function (config) {
		        if (config === void 0) { config = {}; }
		        for (var key in config) {
		            this[key] = config[key];
		        }
		    };
		    return PerfectScrollbarConfig;
		}());
		exports.PerfectScrollbarConfig = PerfectScrollbarConfig;
		

	/***/ },
	/* 25 */
	/***/ function(module, exports) {

		module.exports = "/* perfect-scrollbar v0.6.12 */\n.ps-container{-ms-touch-action:none;touch-action:none;overflow:hidden !important;-ms-overflow-style:none}@supports (-ms-overflow-style: none){.ps-container{overflow:auto !important}}@media screen and (-ms-high-contrast: active), (-ms-high-contrast: none){.ps-container{overflow:auto !important}}.ps-container.ps-active-x>.ps-scrollbar-x-rail,.ps-container.ps-active-y>.ps-scrollbar-y-rail{display:block;background-color:transparent}.ps-container.ps-in-scrolling{pointer-events:none}.ps-container.ps-in-scrolling.ps-x>.ps-scrollbar-x-rail{background-color:#eee;opacity:.9}.ps-container.ps-in-scrolling.ps-x>.ps-scrollbar-x-rail>.ps-scrollbar-x{background-color:#999}.ps-container.ps-in-scrolling.ps-y>.ps-scrollbar-y-rail{background-color:#eee;opacity:.9}.ps-container.ps-in-scrolling.ps-y>.ps-scrollbar-y-rail>.ps-scrollbar-y{background-color:#999}.ps-container>.ps-scrollbar-x-rail{display:none;position:absolute;opacity:0;-webkit-transition:background-color .2s linear, opacity .2s linear;-moz-transition:background-color .2s linear, opacity .2s linear;-o-transition:background-color .2s linear, opacity .2s linear;transition:background-color .2s linear, opacity .2s linear;bottom:0px;height:15px}.ps-container>.ps-scrollbar-x-rail>.ps-scrollbar-x{position:absolute;background-color:#aaa;-webkit-border-radius:6px;-moz-border-radius:6px;border-radius:6px;-webkit-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, -webkit-border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, -webkit-border-radius .2s ease-in-out;-moz-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out, -moz-border-radius .2s ease-in-out;-o-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out, -webkit-border-radius .2s ease-in-out, -moz-border-radius .2s ease-in-out;bottom:2px;height:6px}.ps-container>.ps-scrollbar-x-rail:hover>.ps-scrollbar-x,.ps-container>.ps-scrollbar-x-rail:active>.ps-scrollbar-x{height:11px}.ps-container>.ps-scrollbar-y-rail{display:none;position:absolute;opacity:0;-webkit-transition:background-color .2s linear, opacity .2s linear;-moz-transition:background-color .2s linear, opacity .2s linear;-o-transition:background-color .2s linear, opacity .2s linear;transition:background-color .2s linear, opacity .2s linear;right:0;width:15px}.ps-container>.ps-scrollbar-y-rail>.ps-scrollbar-y{position:absolute;background-color:#aaa;-webkit-border-radius:6px;-moz-border-radius:6px;border-radius:6px;-webkit-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, -webkit-border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, -webkit-border-radius .2s ease-in-out;-moz-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out, -moz-border-radius .2s ease-in-out;-o-transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out;transition:background-color .2s linear, height .2s linear, width .2s ease-in-out, border-radius .2s ease-in-out, -webkit-border-radius .2s ease-in-out, -moz-border-radius .2s ease-in-out;right:2px;width:6px}.ps-container>.ps-scrollbar-y-rail:hover>.ps-scrollbar-y,.ps-container>.ps-scrollbar-y-rail:active>.ps-scrollbar-y{width:11px}.ps-container:hover.ps-in-scrolling{pointer-events:none}.ps-container:hover.ps-in-scrolling.ps-x>.ps-scrollbar-x-rail{background-color:#eee;opacity:.9}.ps-container:hover.ps-in-scrolling.ps-x>.ps-scrollbar-x-rail>.ps-scrollbar-x{background-color:#999}.ps-container:hover.ps-in-scrolling.ps-y>.ps-scrollbar-y-rail{background-color:#eee;opacity:.9}.ps-container:hover.ps-in-scrolling.ps-y>.ps-scrollbar-y-rail>.ps-scrollbar-y{background-color:#999}.ps-container:hover>.ps-scrollbar-x-rail,.ps-container:hover>.ps-scrollbar-y-rail{opacity:.6}.ps-container:hover>.ps-scrollbar-x-rail:hover{background-color:#eee;opacity:.9}.ps-container:hover>.ps-scrollbar-x-rail:hover>.ps-scrollbar-x{background-color:#999}.ps-container:hover>.ps-scrollbar-y-rail:hover{background-color:#eee;opacity:.9}.ps-container:hover>.ps-scrollbar-y-rail:hover>.ps-scrollbar-y{background-color:#999}\n"

	/***/ },
	/* 26 */
	/***/ function(module, exports, __webpack_require__) {

		"use strict";
		var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
		    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
		    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
		    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
		    return c > 3 && r && Object.defineProperty(target, key, r), r;
		};
		var __metadata = (this && this.__metadata) || function (k, v) {
		    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
		};
		var __param = (this && this.__param) || function (paramIndex, decorator) {
		    return function (target, key) { decorator(target, key, paramIndex); }
		};
		var common_1 = __webpack_require__(27);
		var core_1 = __webpack_require__(23);
		var perfect_scrollbar_component_1 = __webpack_require__(1);
		var perfect_scrollbar_config_1 = __webpack_require__(24);
		exports.PERFECT_SCROLLBAR_CONFIG = new core_1.OpaqueToken('PERFECT_SCROLLBAR_CONFIG');
		var PerfectScrollbarModule = (function () {
		    function PerfectScrollbarModule(parentModule) {
		        if (parentModule) {
		            throw new Error("PerfectScrollbarModule is already loaded. \n        Import it in the AppModule only!");
		        }
		    }
		    PerfectScrollbarModule.forRoot = function (config) {
		        return {
		            ngModule: PerfectScrollbarModule,
		            providers: [
		                {
		                    provide: exports.PERFECT_SCROLLBAR_CONFIG,
		                    useValue: config ? config : {}
		                },
		                {
		                    provide: perfect_scrollbar_config_1.PerfectScrollbarConfig,
		                    useFactory: providePerfectScrollbarConfig,
		                    deps: [
		                        exports.PERFECT_SCROLLBAR_CONFIG
		                    ]
		                }
		            ]
		        };
		    };
		    PerfectScrollbarModule = __decorate([
		        core_1.NgModule({
		            imports: [common_1.CommonModule],
		            declarations: [perfect_scrollbar_component_1.PerfectScrollbarComponent],
		            exports: [common_1.CommonModule, perfect_scrollbar_component_1.PerfectScrollbarComponent]
		        }),
		        __param(0, core_1.Optional()),
		        __param(0, core_1.SkipSelf()), 
		        __metadata('design:paramtypes', [PerfectScrollbarModule])
		    ], PerfectScrollbarModule);
		    return PerfectScrollbarModule;
		}());
		exports.PerfectScrollbarModule = PerfectScrollbarModule;
		function providePerfectScrollbarConfig(configInterface) {
		    var config = new perfect_scrollbar_config_1.PerfectScrollbarConfig(configInterface);
		    return config;
		}
		exports.providePerfectScrollbarConfig = providePerfectScrollbarConfig;
		

	/***/ },
	/* 27 */
	/***/ function(module, exports) {

		module.exports = __WEBPACK_EXTERNAL_MODULE_27__;

	/***/ }
	/******/ ])
	});
	;
	//# sourceMappingURL=index.js.map

/***/ },
/* 31 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_31__;

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var __param = (this && this.__param) || function (paramIndex, decorator) {
	    return function (target, key) { decorator(target, key, paramIndex); }
	};
	__webpack_require__(33);
	__webpack_require__(35);
	var Observable_1 = __webpack_require__(4);
	var core_1 = __webpack_require__(28);
	var http_1 = __webpack_require__(42);
	var interfaces_1 = __webpack_require__(43);
	var FontPickerService = (function () {
	    function FontPickerService(config, http) {
	        this.config = config;
	        this.http = http;
	        this.apiKey = "";
	        this.baseUrl = 'https://www.googleapis.com/webfonts/v1/webfonts';
	        this.apiKey = config.apiKey;
	    }
	    /*
	      Return all fonts avaliable from google fonts, may have sort parameter:
	      date || alpha || style || trending || popularity
	    */
	    FontPickerService.prototype.getAllFonts = function (sort) {
	        var requestUrl = this.baseUrl + '?key=' + this.apiKey;
	        if (sort) {
	            requestUrl = requestUrl.concat('&sort=' + sort);
	        }
	        return this.http.get(requestUrl)
	            .map(function (res) { return res.json(); })
	            .catch(this.handleHttpError);
	    };
	    /*
	      Return observable of the requested font
	    */
	    FontPickerService.prototype.getRequestedFont = function (family) {
	        var requestUrl = 'https://fonts.googleapis.com/css?family=' + family;
	        return this.http.get(requestUrl)
	            .map(function (res) { return res.json(); })
	            .catch(this.handleHttpError);
	    };
	    /*
	      Handler for possible http request errors
	    */
	    FontPickerService.prototype.handleHttpError = function (error) {
	        var errMsg = (error.message) ? error.message :
	            error.status ? error.status + " - " + error.statusText : 'Server error';
	        return Observable_1.Observable.throw(errMsg);
	    };
	    FontPickerService = __decorate([
	        core_1.Injectable(),
	        __param(0, core_1.Inject(interfaces_1.FontPickerConfig)), 
	        __metadata('design:paramtypes', [interfaces_1.FontPickerConfig, http_1.Http])
	    ], FontPickerService);
	    return FontPickerService;
	}());
	exports.FontPickerService = FontPickerService;
	

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Observable_1 = __webpack_require__(4);
	var map_1 = __webpack_require__(34);
	Observable_1.Observable.prototype.map = map_1.map;
	//# sourceMappingURL=map.js.map

/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscriber_1 = __webpack_require__(8);
	/**
	 * Applies a given `project` function to each value emitted by the source
	 * Observable, and emits the resulting values as an Observable.
	 *
	 * <span class="informal">Like [Array.prototype.map()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/map),
	 * it passes each source value through a transformation function to get
	 * corresponding output values.</span>
	 *
	 * <img src="./img/map.png" width="100%">
	 *
	 * Similar to the well known `Array.prototype.map` function, this operator
	 * applies a projection to each value and emits that projection in the output
	 * Observable.
	 *
	 * @example <caption>Map every every click to the clientX position of that click</caption>
	 * var clicks = Rx.Observable.fromEvent(document, 'click');
	 * var positions = clicks.map(ev => ev.clientX);
	 * positions.subscribe(x => console.log(x));
	 *
	 * @see {@link mapTo}
	 * @see {@link pluck}
	 *
	 * @param {function(value: T, index: number): R} project The function to apply
	 * to each `value` emitted by the source Observable. The `index` parameter is
	 * the number `i` for the i-th emission that has happened since the
	 * subscription, starting from the number `0`.
	 * @param {any} [thisArg] An optional argument to define what `this` is in the
	 * `project` function.
	 * @return {Observable<R>} An Observable that emits the values from the source
	 * Observable transformed by the given `project` function.
	 * @method map
	 * @owner Observable
	 */
	function map(project, thisArg) {
	    if (typeof project !== 'function') {
	        throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
	    }
	    return this.lift(new MapOperator(project, thisArg));
	}
	exports.map = map;
	var MapOperator = (function () {
	    function MapOperator(project, thisArg) {
	        this.project = project;
	        this.thisArg = thisArg;
	    }
	    MapOperator.prototype.call = function (subscriber, source) {
	        return source._subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
	    };
	    return MapOperator;
	}());
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var MapSubscriber = (function (_super) {
	    __extends(MapSubscriber, _super);
	    function MapSubscriber(destination, project, thisArg) {
	        _super.call(this, destination);
	        this.project = project;
	        this.count = 0;
	        this.thisArg = thisArg || this;
	    }
	    // NOTE: This looks unoptimized, but it's actually purposefully NOT
	    // using try/catch optimizations.
	    MapSubscriber.prototype._next = function (value) {
	        var result;
	        try {
	            result = this.project.call(this.thisArg, value, this.count++);
	        }
	        catch (err) {
	            this.destination.error(err);
	            return;
	        }
	        this.destination.next(result);
	    };
	    return MapSubscriber;
	}(Subscriber_1.Subscriber));
	//# sourceMappingURL=map.js.map

/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Observable_1 = __webpack_require__(4);
	var catch_1 = __webpack_require__(36);
	Observable_1.Observable.prototype.catch = catch_1._catch;
	//# sourceMappingURL=catch.js.map

/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var OuterSubscriber_1 = __webpack_require__(37);
	var subscribeToResult_1 = __webpack_require__(38);
	/**
	 * Catches errors on the observable to be handled by returning a new observable or throwing an error.
	 * @param {function} selector a function that takes as arguments `err`, which is the error, and `caught`, which
	 *  is the source observable, in case you'd like to "retry" that observable by returning it again. Whatever observable
	 *  is returned by the `selector` will be used to continue the observable chain.
	 * @return {Observable} an observable that originates from either the source or the observable returned by the
	 *  catch `selector` function.
	 * @method catch
	 * @owner Observable
	 */
	function _catch(selector) {
	    var operator = new CatchOperator(selector);
	    var caught = this.lift(operator);
	    return (operator.caught = caught);
	}
	exports._catch = _catch;
	var CatchOperator = (function () {
	    function CatchOperator(selector) {
	        this.selector = selector;
	    }
	    CatchOperator.prototype.call = function (subscriber, source) {
	        return source._subscribe(new CatchSubscriber(subscriber, this.selector, this.caught));
	    };
	    return CatchOperator;
	}());
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var CatchSubscriber = (function (_super) {
	    __extends(CatchSubscriber, _super);
	    function CatchSubscriber(destination, selector, caught) {
	        _super.call(this, destination);
	        this.selector = selector;
	        this.caught = caught;
	    }
	    // NOTE: overriding `error` instead of `_error` because we don't want
	    // to have this flag this subscriber as `isStopped`.
	    CatchSubscriber.prototype.error = function (err) {
	        if (!this.isStopped) {
	            var result = void 0;
	            try {
	                result = this.selector(err, this.caught);
	            }
	            catch (err) {
	                this.destination.error(err);
	                return;
	            }
	            this.unsubscribe();
	            this.destination.remove(this);
	            subscribeToResult_1.subscribeToResult(this, result);
	        }
	    };
	    return CatchSubscriber;
	}(OuterSubscriber_1.OuterSubscriber));
	//# sourceMappingURL=catch.js.map

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscriber_1 = __webpack_require__(8);
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var OuterSubscriber = (function (_super) {
	    __extends(OuterSubscriber, _super);
	    function OuterSubscriber() {
	        _super.apply(this, arguments);
	    }
	    OuterSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
	        this.destination.next(innerValue);
	    };
	    OuterSubscriber.prototype.notifyError = function (error, innerSub) {
	        this.destination.error(error);
	    };
	    OuterSubscriber.prototype.notifyComplete = function (innerSub) {
	        this.destination.complete();
	    };
	    return OuterSubscriber;
	}(Subscriber_1.Subscriber));
	exports.OuterSubscriber = OuterSubscriber;
	//# sourceMappingURL=OuterSubscriber.js.map

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var root_1 = __webpack_require__(5);
	var isArray_1 = __webpack_require__(11);
	var isPromise_1 = __webpack_require__(39);
	var Observable_1 = __webpack_require__(4);
	var iterator_1 = __webpack_require__(40);
	var InnerSubscriber_1 = __webpack_require__(41);
	var observable_1 = __webpack_require__(18);
	function subscribeToResult(outerSubscriber, result, outerValue, outerIndex) {
	    var destination = new InnerSubscriber_1.InnerSubscriber(outerSubscriber, outerValue, outerIndex);
	    if (destination.closed) {
	        return null;
	    }
	    if (result instanceof Observable_1.Observable) {
	        if (result._isScalar) {
	            destination.next(result.value);
	            destination.complete();
	            return null;
	        }
	        else {
	            return result.subscribe(destination);
	        }
	    }
	    if (isArray_1.isArray(result)) {
	        for (var i = 0, len = result.length; i < len && !destination.closed; i++) {
	            destination.next(result[i]);
	        }
	        if (!destination.closed) {
	            destination.complete();
	        }
	    }
	    else if (isPromise_1.isPromise(result)) {
	        result.then(function (value) {
	            if (!destination.closed) {
	                destination.next(value);
	                destination.complete();
	            }
	        }, function (err) { return destination.error(err); })
	            .then(null, function (err) {
	            // Escaping the Promise trap: globally throw unhandled errors
	            root_1.root.setTimeout(function () { throw err; });
	        });
	        return destination;
	    }
	    else if (typeof result[iterator_1.$$iterator] === 'function') {
	        var iterator = result[iterator_1.$$iterator]();
	        do {
	            var item = iterator.next();
	            if (item.done) {
	                destination.complete();
	                break;
	            }
	            destination.next(item.value);
	            if (destination.closed) {
	                break;
	            }
	        } while (true);
	    }
	    else if (typeof result[observable_1.$$observable] === 'function') {
	        var obs = result[observable_1.$$observable]();
	        if (typeof obs.subscribe !== 'function') {
	            destination.error(new Error('invalid observable'));
	        }
	        else {
	            return obs.subscribe(new InnerSubscriber_1.InnerSubscriber(outerSubscriber, outerValue, outerIndex));
	        }
	    }
	    else {
	        destination.error(new TypeError('unknown type returned'));
	    }
	    return null;
	}
	exports.subscribeToResult = subscribeToResult;
	//# sourceMappingURL=subscribeToResult.js.map

/***/ },
/* 39 */
/***/ function(module, exports) {

	"use strict";
	function isPromise(value) {
	    return value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
	}
	exports.isPromise = isPromise;
	//# sourceMappingURL=isPromise.js.map

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var root_1 = __webpack_require__(5);
	var Symbol = root_1.root.Symbol;
	if (typeof Symbol === 'function') {
	    if (Symbol.iterator) {
	        exports.$$iterator = Symbol.iterator;
	    }
	    else if (typeof Symbol.for === 'function') {
	        exports.$$iterator = Symbol.for('iterator');
	    }
	}
	else {
	    if (root_1.root.Set && typeof new root_1.root.Set()['@@iterator'] === 'function') {
	        // Bug for mozilla version
	        exports.$$iterator = '@@iterator';
	    }
	    else if (root_1.root.Map) {
	        // es6-shim specific logic
	        var keys = Object.getOwnPropertyNames(root_1.root.Map.prototype);
	        for (var i = 0; i < keys.length; ++i) {
	            var key = keys[i];
	            if (key !== 'entries' && key !== 'size' && root_1.root.Map.prototype[key] === root_1.root.Map.prototype['entries']) {
	                exports.$$iterator = key;
	                break;
	            }
	        }
	    }
	    else {
	        exports.$$iterator = '@@iterator';
	    }
	}
	//# sourceMappingURL=iterator.js.map

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Subscriber_1 = __webpack_require__(8);
	/**
	 * We need this JSDoc comment for affecting ESDoc.
	 * @ignore
	 * @extends {Ignored}
	 */
	var InnerSubscriber = (function (_super) {
	    __extends(InnerSubscriber, _super);
	    function InnerSubscriber(parent, outerValue, outerIndex) {
	        _super.call(this);
	        this.parent = parent;
	        this.outerValue = outerValue;
	        this.outerIndex = outerIndex;
	        this.index = 0;
	    }
	    InnerSubscriber.prototype._next = function (value) {
	        this.parent.notifyNext(this.outerValue, value, this.outerIndex, this.index++, this);
	    };
	    InnerSubscriber.prototype._error = function (error) {
	        this.parent.notifyError(error, this);
	        this.unsubscribe();
	    };
	    InnerSubscriber.prototype._complete = function () {
	        this.parent.notifyComplete(this);
	        this.unsubscribe();
	    };
	    return InnerSubscriber;
	}(Subscriber_1.Subscriber));
	exports.InnerSubscriber = InnerSubscriber;
	//# sourceMappingURL=InnerSubscriber.js.map

/***/ },
/* 42 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_42__;

/***/ },
/* 43 */
/***/ function(module, exports) {

	"use strict";
	var FontPickerConfig = (function () {
	    function FontPickerConfig() {
	        this.apiKey = null;
	    }
	    return FontPickerConfig;
	}());
	exports.FontPickerConfig = FontPickerConfig;
	var Font = (function () {
	    function Font(props) {
	        this.family = props.family || 'monospace';
	        this.styles = props.styles || ['regular'];
	        this.files = props.files || null;
	        this.style = props.style || 'regular';
	        this.size = props.size || 14;
	    }
	    Font.prototype.getStyles = function () {
	        return {
	            'font-size': this.size.toString() + 'px',
	            'font-family': this.family || 'monospace',
	            'font-weight': this.style.includes('regular') || isNaN(Number(this.style.slice(0, 3))) ? 'normal' : this.style.slice(0, 3),
	            'font-style': this.style.includes('i') || this.style.includes('italic') ? 'italic' : 'normal'
	        };
	    };
	    return Font;
	}());
	exports.Font = Font;
	var GoogleFonts = (function () {
	    function GoogleFonts() {
	    }
	    return GoogleFonts;
	}());
	exports.GoogleFonts = GoogleFonts;
	

/***/ },
/* 44 */
/***/ function(module, exports) {

	module.exports = "<div class=\"font-picker\" *ngIf=\"show\" [style.height.px]=\"fpHeight\" [style.width.px]=\"fpWidth\" [style.top.px]=\"top\" [style.left.px]=\"left\" [style.position]=\"position\">\n  <div class=\"arrow arrow-{{fpPosition}}\" [style.top.px]=\"arrowTop\"></div>\n\n  <div class=\"search-box\">\n    <input class=\"search-field\" placeholder=\"Search from Google Web Fonts...\" [disabled]=\"fpPresetFonts?.length\" [formControl]=\"searchTerm\" />\n\n    <div class=\"search-reset\" [hidden]=\"!searchTerm.value\" (click)=\"onSearchReset($event)\">×</div>\n  </div>\n\n\t<perfect-scrollbar class=\"font-list\" [config]=\"PERFECT_SCROLLBAR_CONFIG\">\n    <div class=\"list-label\">{{listLabel}}</div>\n\n  \t<div *ngFor=\"let fontItem of currentFonts | StatefulSlice:0:loadedFonts\" class=\"font-item\" (click)=\"onSelectFont(fontItem)\" [ngClass]=\"{selected: fontItem.family.toLowerCase() == font.family.toLowerCase() }\">\n  \t  <div class=\"font-info\">\n        <span class=\"font-name\">{{fontItem.family}}</span>\n\n        <div *ngIf=\"!fontItem.files\" class=\"not-available-label\">Not a Google Font</div>\n      </div>\n\n      <div class=\"font-text\" [ngStyle]=\"{'font-family': fontItem.family}\">ABCDEabcde12345@€!?-</div>\n  \t</div>\n\t</perfect-scrollbar>\n\n  <div class=\"options-box\">\n  \t<div class=\"font-options\">\n   \t\t<div class=\"left\">\n     \t\t<select class=\"select-style\" (change)=\"onFontStyleChange($event, font)\" [(ngModel)]=\"font.style\" [disabled]=\"!font.styles\">\n   \t \t  \t<option *ngFor=\"let style of font.styles\" [value]=\"style\">{{style | FontStyles}}</option>\n   \t\t\t</select>\n  \t\t</div>\n\n   \t\t<div class=\"right\">\n     \t\t<input class=\"size-input\" type=\"number\" pattern=\"[0-9]*\" min=\"1\" max=\"100\" [(ngModel)]=\"font.size\" />\n   \t  </div>\n   \t</div>\n  </div>\n\n  <button *ngIf=\"fpUploadButton\" type=\"button\" class=\"{{fpUploadButtonClass}}\" (click)=\"uploadFontFiles()\">{{fpUploadButtonText}}</button>\n\n  <button *ngIf=\"fpCancelButton\" type=\"button\" class=\"{{fpCancelButtonClass}}\" (click)=\"cancelFontSelect()\">{{fpCancelButtonText}}</button>\n</div>\n"

/***/ },
/* 45 */
/***/ function(module, exports) {

	module.exports = ".font-picker {\n  position: absolute;\n  z-index: 1000;\n  top: 250px;\n  left: 30px;\n  display: flex;\n  width: 230px;\n  height: 280px;\n  flex-direction: column;\n  border: #777 solid 1px;\n  cursor: default;\n  background-color: #fff;\n  font-family: 'Open Sans', sans-serif;\n  -webkit-touch-callout: none;\n  -khtml-user-select: none;\n  -moz-user-select: none;\n  -ms-user-select: none;\n  -webkit-user-select: none;\n  user-select: none; }\n  .font-picker input,\n  .font-picker select {\n    width: 100%;\n    padding: 8px 16px;\n    border: none;\n    outline: none;\n    border-bottom: 2px solid #cfcfcf;\n    font-size: 14px;\n    text-align: left;\n    background: none;\n    line-height: 18px;\n    transition: border 0.3s ease;\n    -moz-appearance: textfield; }\n    .font-picker input:hover, .font-picker input:focus, .font-picker input:active,\n    .font-picker select:hover,\n    .font-picker select:focus,\n    .font-picker select:active {\n      border-bottom: 2px solid #999; }\n    .font-picker input:invalid,\n    .font-picker select:invalid {\n      box-shadow: none; }\n    .font-picker input:-moz-submit-invalid,\n    .font-picker select:-moz-submit-invalid {\n      box-shadow: none; }\n    .font-picker input:-moz-ui-invalid,\n    .font-picker select:-moz-ui-invalid {\n      box-shadow: none; }\n    .font-picker input::-webkit-inner-spin-button, .font-picker input::-webkit-outer-spin-button,\n    .font-picker select::-webkit-inner-spin-button,\n    .font-picker select::-webkit-outer-spin-button {\n      -webkit-appearance: none;\n      margin: 0; }\n  .font-picker .font-list {\n    position: relative;\n    overflow: hidden;\n    flex: 1 1 auto; }\n    .font-picker .font-list .font-item {\n      cursor: pointer;\n      padding: 8px 16px;\n      border-bottom: 1px solid #cfcfcf; }\n      .font-picker .font-list .font-item.selected {\n        background: #e6e6e6;\n        pointer-events: none;\n        cursor: default; }\n      .font-picker .font-list .font-item .font-info {\n        margin-bottom: 4px; }\n        .font-picker .font-list .font-item .font-info .font-name {\n          color: #555;\n          font-size: 14px;\n          text-transform: capitalize; }\n        .font-picker .font-list .font-item .font-info .not-available-label {\n          position: relative;\n          text-transform: none;\n          color: #ef8b80;\n          font-size: 12px;\n          font-weight: 600; }\n          .font-picker .font-list .font-item .font-info .not-available-label::after {\n            content: 'This font is not from Google Fonts. If you select it, you might have to inject it in your website';\n            position: absolute;\n            top: 16px;\n            left: 0;\n            width: 230px;\n            height: auto;\n            padding: 2px 4px;\n            border-radius: 2px;\n            opacity: 0;\n            color: white;\n            font-size: 12px;\n            font-weight: normal;\n            background: rgba(60, 60, 60, 0.8);\n            pointer-events: none; }\n          .font-picker .font-list .font-item .font-info .not-available-label:hover {\n            color: #ea6153; }\n            .font-picker .font-list .font-item .font-info .not-available-label:hover::after {\n              opacity: 1; }\n      .font-picker .font-list .font-item .font-text {\n        color: #999;\n        font-size: 16px;\n        padding: 4px 0;\n        text-align: right; }\n  .font-picker .fp-upload-button-class,\n  .font-picker .fp-cancel-button-class {\n    text-align: center;\n    text-transform: uppercase; }\n  .font-picker .arrow {\n    position: absolute;\n    z-index: 999999;\n    width: 0;\n    height: 0;\n    border-style: solid; }\n  .font-picker .arrow-right {\n    top: 10px;\n    left: -20px;\n    border-width: 5px 10px;\n    border-color: transparent #777 transparent transparent; }\n  .font-picker .arrow-left {\n    top: 10px;\n    left: 231px;\n    border-width: 5px 10px;\n    border-color: transparent transparent transparent #777; }\n  .font-picker .arrow-bottom {\n    top: -20px;\n    left: 10px;\n    border-width: 10px 5px;\n    border-color: transparent transparent #777 transparent; }\n  .font-picker .arrow-top {\n    left: 10px;\n    border-width: 10px 5px;\n    border-color: #777 transparent transparent transparent; }\n  .font-picker .size-input {\n    width: 35px;\n    padding: 8px 0;\n    text-align: center; }\n  .font-picker .list-label {\n    overflow: hidden;\n    box-sizing: border-box;\n    width: 100%;\n    max-width: 100%;\n    padding: 8px 16px;\n    border-bottom: 1px solid #cfcfcf;\n    color: #555;\n    font-size: 11px;\n    text-align: left;\n    font-weight: bold;\n    white-space: nowrap;\n    text-overflow: ellipsis; }\n  .font-picker .search-box {\n    position: relative; }\n  .font-picker .search-field {\n    box-sizing: border-box;\n    padding: 12px 48px 12px 16px; }\n    .font-picker .search-field:disabled {\n      opacity: 0.5;\n      cursor: not-allowed;\n      background-color: #888; }\n  .font-picker .search-reset {\n    position: absolute;\n    top: 0;\n    right: 0;\n    padding: 12px 16px;\n    color: #777;\n    font-size: 16px;\n    cursor: pointer;\n    transition: color 0.3s ease; }\n    .font-picker .search-reset:hover {\n      color: #555; }\n  .font-picker .font-options {\n    display: flex;\n    box-sizing: border-box;\n    padding: 5px 15px;\n    border-top: 2px solid #cfcfcf; }\n    .font-picker .font-options .left {\n      flex: 1 1 auto;\n      padding: 0 2px; }\n      .font-picker .font-options .left .select-style {\n        text-transform: capitalize; }\n        .font-picker .font-options .left .select-style:disabled {\n          background-color: #777; }\n    .font-picker .font-options .right {\n      padding: 0 2px; }\n"

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var core_1 = __webpack_require__(28);
	var font_picker_service_1 = __webpack_require__(32);
	var font_picker_component_1 = __webpack_require__(1);
	var interfaces_1 = __webpack_require__(43);
	var FontPickerDirective = (function () {
	    function FontPickerDirective(el, vc, cd, dcl, service) {
	        this.el = el;
	        this.vc = vc;
	        this.cd = cd;
	        this.dcl = dcl;
	        this.service = service;
	        this.created = false;
	        this.fpWidth = '280px';
	        this.fpHeight = '320px';
	        this.fpFallbackFont = new interfaces_1.Font({
	            family: 'Roboto',
	            styles: ['regular'],
	            style: 'regular',
	            size: 14
	        });
	        this.fpPosition = 'right';
	        this.fpPositionOffset = '0%';
	        this.fpPositionRelativeToArrow = false;
	        this.fpCancelButton = false;
	        this.fpCancelButtonText = 'Cancel';
	        this.fpCancelButtonClass = 'fp-cancel-button-class';
	        this.fpUploadButton = false;
	        this.fpUploadButtonText = 'Upload';
	        this.fpUploadButtonClass = 'fp-upload-button-class';
	        this.fontPickerChange = new core_1.EventEmitter();
	    }
	    FontPickerDirective.prototype.ngOnInit = function () {
	        var fontPicker = this.fontPicker;
	        if (!this.fontPicker) {
	            this.fontPicker = this.fpFallbackFont;
	        }
	        this.fontPickerChange.emit(this.fontPicker);
	        if (fontPicker != this.fontPicker) {
	            this.cd.detectChanges();
	        }
	    };
	    FontPickerDirective.prototype.onClick = function () {
	        var _this = this;
	        if (!this.created) {
	            this.created = true;
	            this.dcl.loadNextToLocation(font_picker_component_1.FontPickerComponent, this.vc)
	                .then(function (res) {
	                res.instance.setDialog(_this, _this.el, _this.fontPicker, _this.fpPosition, _this.fpPositionOffset, _this.fpPositionRelativeToArrow, _this.fpPresetLabel, _this.fpPresetFonts, _this.fpUploadButton, _this.fpUploadButtonClass, _this.fpUploadButtonText, _this.fpCancelButton, _this.fpCancelButtonClass, _this.fpCancelButtonText, _this.fpHeight, _this.fpWidth);
	                _this.dialog = res.instance;
	            });
	        }
	        else if (this.dialog) {
	            this.dialog.updateDialog(this.fontPicker, this.fpPresetLabel, this.fpPresetFonts);
	            this.dialog.openFontPicker();
	        }
	    };
	    __decorate([
	        core_1.Input('fontPicker'), 
	        __metadata('design:type', interfaces_1.Font)
	    ], FontPickerDirective.prototype, "fontPicker", void 0);
	    __decorate([
	        core_1.Input('fpWidth'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpWidth", void 0);
	    __decorate([
	        core_1.Input('fpHeight'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpHeight", void 0);
	    __decorate([
	        core_1.Input('fpFallbackFont'), 
	        __metadata('design:type', interfaces_1.Font)
	    ], FontPickerDirective.prototype, "fpFallbackFont", void 0);
	    __decorate([
	        core_1.Input('fpPresetLabel'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpPresetLabel", void 0);
	    __decorate([
	        core_1.Input('fpPresetFonts'), 
	        __metadata('design:type', Array)
	    ], FontPickerDirective.prototype, "fpPresetFonts", void 0);
	    __decorate([
	        core_1.Input('fpPosition'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpPosition", void 0);
	    __decorate([
	        core_1.Input('fpPositionOffset'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpPositionOffset", void 0);
	    __decorate([
	        core_1.Input('fpPositionRelativeToArrow'), 
	        __metadata('design:type', Boolean)
	    ], FontPickerDirective.prototype, "fpPositionRelativeToArrow", void 0);
	    __decorate([
	        core_1.Input('fpCancelButton'), 
	        __metadata('design:type', Boolean)
	    ], FontPickerDirective.prototype, "fpCancelButton", void 0);
	    __decorate([
	        core_1.Input('fpCancelButtonText'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpCancelButtonText", void 0);
	    __decorate([
	        core_1.Input('fpCancelButtonClass'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpCancelButtonClass", void 0);
	    __decorate([
	        core_1.Input('fpUploadButton'), 
	        __metadata('design:type', Boolean)
	    ], FontPickerDirective.prototype, "fpUploadButton", void 0);
	    __decorate([
	        core_1.Input('fpUploadButtonText'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpUploadButtonText", void 0);
	    __decorate([
	        core_1.Input('fpUploadButtonClass'), 
	        __metadata('design:type', String)
	    ], FontPickerDirective.prototype, "fpUploadButtonClass", void 0);
	    __decorate([
	        core_1.Output('fontPickerChange'), 
	        __metadata('design:type', Object)
	    ], FontPickerDirective.prototype, "fontPickerChange", void 0);
	    FontPickerDirective = __decorate([
	        core_1.Directive({
	            selector: '[fontPicker]',
	            host: {
	                '(click)': 'onClick()'
	            }
	        }), 
	        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ViewContainerRef, core_1.ChangeDetectorRef, core_1.DynamicComponentLoader, font_picker_service_1.FontPickerService])
	    ], FontPickerDirective);
	    return FontPickerDirective;
	}());
	exports.FontPickerDirective = FontPickerDirective;
	

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var __param = (this && this.__param) || function (paramIndex, decorator) {
	    return function (target, key) { decorator(target, key, paramIndex); }
	};
	var core_1 = __webpack_require__(28);
	var http_1 = __webpack_require__(42);
	var common_1 = __webpack_require__(31);
	var forms_1 = __webpack_require__(29);
	var angular2_perfect_scrollbar_1 = __webpack_require__(30);
	var font_picker_service_1 = __webpack_require__(32);
	var font_picker_component_1 = __webpack_require__(1);
	var font_picker_directive_1 = __webpack_require__(46);
	var pipes_1 = __webpack_require__(48);
	var interfaces_1 = __webpack_require__(43);
	exports.FONT_PICKER_CONFIG = new core_1.OpaqueToken('FONT_PICKER_CONFIG');
	var FontPickerModule = (function () {
	    function FontPickerModule(parentModule) {
	        if (parentModule) {
	            throw new Error("FontPickerModule is already loaded.\n        Import it in the AppModule only!");
	        }
	    }
	    FontPickerModule.forRoot = function (config) {
	        return {
	            ngModule: FontPickerModule,
	            providers: [
	                font_picker_service_1.FontPickerService,
	                {
	                    provide: exports.FONT_PICKER_CONFIG,
	                    useValue: config ? config : {}
	                },
	                {
	                    provide: interfaces_1.FontPickerConfig,
	                    useFactory: provideFontPickerConfig,
	                    deps: [
	                        exports.FONT_PICKER_CONFIG
	                    ]
	                }
	            ]
	        };
	    };
	    FontPickerModule = __decorate([
	        core_1.NgModule({
	            imports: [common_1.CommonModule, http_1.HttpModule, forms_1.FormsModule, forms_1.ReactiveFormsModule, angular2_perfect_scrollbar_1.PerfectScrollbarModule],
	            declarations: [font_picker_component_1.FontPickerComponent, font_picker_directive_1.FontPickerDirective, pipes_1.FontStylesPipe, pipes_1.StatefulSlicePipe],
	            exports: [common_1.CommonModule, http_1.HttpModule, forms_1.FormsModule, forms_1.ReactiveFormsModule, font_picker_component_1.FontPickerComponent, font_picker_directive_1.FontPickerDirective, pipes_1.FontStylesPipe, pipes_1.StatefulSlicePipe]
	        }),
	        __param(0, core_1.Optional()),
	        __param(0, core_1.SkipSelf()), 
	        __metadata('design:paramtypes', [FontPickerModule])
	    ], FontPickerModule);
	    return FontPickerModule;
	}());
	exports.FontPickerModule = FontPickerModule;
	function provideFontPickerConfig(configInterface) {
	    if (configInterface === void 0) { configInterface = {}; }
	    var config = new interfaces_1.FontPickerConfig();
	    config.apiKey = configInterface.apiKey || '';
	    return config;
	}
	exports.provideFontPickerConfig = provideFontPickerConfig;
	

/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var __metadata = (this && this.__metadata) || function (k, v) {
	    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
	};
	var core_1 = __webpack_require__(28);
	var FontStylesPipe = (function () {
	    function FontStylesPipe() {
	    }
	    FontStylesPipe.prototype.transform = function (value) {
	        var lookup = {
	            "100": "Thin",
	            "200": "Extra-Light",
	            "300": "Light",
	            "400": "Regular",
	            "500": "Medium",
	            "600": "Semi-bold",
	            "700": "Bold",
	            "800": "Extra-bold",
	            "900": "Black"
	        };
	        for (var style in lookup) {
	            var found = value.search(style);
	            if (found >= 0) {
	                value = value.replace(style, lookup[style] + " ");
	                break;
	            }
	        }
	        return value;
	    };
	    FontStylesPipe = __decorate([
	        core_1.Pipe({ name: 'FontStyles', pure: true }), 
	        __metadata('design:paramtypes', [])
	    ], FontStylesPipe);
	    return FontStylesPipe;
	}());
	exports.FontStylesPipe = FontStylesPipe;
	var StatefulSlicePipe = (function () {
	    function StatefulSlicePipe() {
	        this.slicedArray = [];
	        this.previousArrayRef = [];
	        this.previousEndValue = null;
	    }
	    StatefulSlicePipe.prototype.transform = function (arr, start, end) {
	        if (arr && (this.previousEndValue != end || this.previousArrayRef !== arr)) {
	            this.slicedArray = arr.slice(start, end);
	            this.previousArrayRef = arr;
	            this.previousEndValue = end;
	        }
	        return this.slicedArray || arr;
	    };
	    StatefulSlicePipe = __decorate([
	        core_1.Pipe({ name: 'StatefulSlice', pure: false }), 
	        __metadata('design:paramtypes', [])
	    ], StatefulSlicePipe);
	    return StatefulSlicePipe;
	}());
	exports.StatefulSlicePipe = StatefulSlicePipe;
	

/***/ }
/******/ ])
});
;
//# sourceMappingURL=index.js.map