import "rxjs/add/operator/debounceTime";
import "rxjs/add/operator/distinctUntilChanged";
import { OnInit, ElementRef } from '@angular/core';
import { PerfectScrollbarComponent, PerfectScrollbarConfigInterface } from 'angular2-perfect-scrollbar';
import { FontPickerService } from './font-picker.service';
import { Font, GoogleFontInterface } from './interfaces';
export declare class FontPickerComponent implements OnInit {
    private el;
    private service;
    PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface;
    private show;
    private loading;
    private top;
    private left;
    private position;
    private listLabel;
    private testWidth;
    private testContainer;
    private font;
    private initialFont;
    private styles;
    private currentFonts;
    private presetFonts;
    private googleFonts;
    private directiveInstance;
    private directiveElementRef;
    private listenerResize;
    private listenerMouseDown;
    private fpWidth;
    private fpHeight;
    private fpPosition;
    private fpPositionOffset;
    private fpPresetLabel;
    private fpPresetFonts;
    private fpCancelButton;
    private fpCancelButtonText;
    private fpCancelButtonClass;
    private fpUploadButton;
    private fpUploadButtonText;
    private fpUploadButtonClass;
    private arrowTop;
    private dialogArrowSize;
    private dialogArrowOffset;
    private searchTerm;
    private fontAmount;
    private loadedFonts;
    scrollbar: PerfectScrollbarComponent;
    constructor(el: ElementRef, service: FontPickerService);
    setDialog(instance: any, elementRef: ElementRef, font: Font, fpPosition: string, fpPositionOffset: string, fpPositionRelativeToArrow: boolean, fpPresetLabel: any, fpPresetFonts: any, fpUploadButton: boolean, fpUploadButtonClass: string, fpUploadButtonText: string, fpCancelButton: boolean, fpCancelButtonClass: string, fpCancelButtonText: string, fpHeight: string, fpWidth: string): void;
    convertGoogleFont(font: GoogleFontInterface): Font;
    updateDialog(font: Font, fpPresetLabel: any, fpPresetFonts: any): void;
    setDisplayedFontSource(): void;
    getPresetFonts(): any[];
    setcurrentFonts(target: Font[]): void;
    findFont(searchVal: any, exactMatch?: boolean): Font;
    findFonts(searchVal: any, exactMatch?: boolean): Font[];
    ngOnInit(): void;
    onResize(): void;
    onMouseDown(event: any): void;
    onSelectFont(font: any): void;
    loadMoreFonts(): void;
    onSearchReset(event?: any): void;
    searchGoogleFonts(value: string): void;
    isDescendant(parent: any, child: any): boolean;
    openFontPicker(): void;
    closeFontPicker(): void;
    isFontAvailable(font: Font): boolean;
    uploadFontFiles(): void;
    cancelFontSelect(): void;
    loadGoogleFonts(fonts: Font[]): void;
    onFontStyleChange($event: any, font: Font): void;
    createDialogBox(element: any, offset: any): any;
    setDialogPosition(): void;
}
